/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AccountReport', 'model/Article', 'model/ArticleComplete', 'model/ArticleCompletePrivate', 'model/ArticleConfidentiality', 'model/ArticleCreate', 'model/ArticleDOI', 'model/ArticleEmbargo', 'model/ArticleEmbargoUpdater', 'model/ArticleHandle', 'model/ArticleSearch', 'model/ArticleUpdate', 'model/ArticleVersions', 'model/ArticleWithProject', 'model/Author', 'model/AuthorsCreator', 'model/CategoriesCreator', 'model/Category', 'model/ConfidentialityCreator', 'model/ErrorMessage', 'model/FileCreator', 'model/FileId', 'model/Location', 'model/LocationWarnings', 'model/LocationWarningsUpdate', 'model/PrivateArticleSearch', 'model/PrivateFile', 'model/PrivateLink', 'model/PrivateLinkCreator', 'model/PrivateLinkResponse', 'model/PublicFile', 'model/Resource'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AccountReport'), require('../model/Article'), require('../model/ArticleComplete'), require('../model/ArticleCompletePrivate'), require('../model/ArticleConfidentiality'), require('../model/ArticleCreate'), require('../model/ArticleDOI'), require('../model/ArticleEmbargo'), require('../model/ArticleEmbargoUpdater'), require('../model/ArticleHandle'), require('../model/ArticleSearch'), require('../model/ArticleUpdate'), require('../model/ArticleVersions'), require('../model/ArticleWithProject'), require('../model/Author'), require('../model/AuthorsCreator'), require('../model/CategoriesCreator'), require('../model/Category'), require('../model/ConfidentialityCreator'), require('../model/ErrorMessage'), require('../model/FileCreator'), require('../model/FileId'), require('../model/Location'), require('../model/LocationWarnings'), require('../model/LocationWarningsUpdate'), require('../model/PrivateArticleSearch'), require('../model/PrivateFile'), require('../model/PrivateLink'), require('../model/PrivateLinkCreator'), require('../model/PrivateLinkResponse'), require('../model/PublicFile'), require('../model/Resource'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ArticlesApi = factory(root.FigshareApi.ApiClient, root.FigshareApi.AccountReport, root.FigshareApi.Article, root.FigshareApi.ArticleComplete, root.FigshareApi.ArticleCompletePrivate, root.FigshareApi.ArticleConfidentiality, root.FigshareApi.ArticleCreate, root.FigshareApi.ArticleDOI, root.FigshareApi.ArticleEmbargo, root.FigshareApi.ArticleEmbargoUpdater, root.FigshareApi.ArticleHandle, root.FigshareApi.ArticleSearch, root.FigshareApi.ArticleUpdate, root.FigshareApi.ArticleVersions, root.FigshareApi.ArticleWithProject, root.FigshareApi.Author, root.FigshareApi.AuthorsCreator, root.FigshareApi.CategoriesCreator, root.FigshareApi.Category, root.FigshareApi.ConfidentialityCreator, root.FigshareApi.ErrorMessage, root.FigshareApi.FileCreator, root.FigshareApi.FileId, root.FigshareApi.Location, root.FigshareApi.LocationWarnings, root.FigshareApi.LocationWarningsUpdate, root.FigshareApi.PrivateArticleSearch, root.FigshareApi.PrivateFile, root.FigshareApi.PrivateLink, root.FigshareApi.PrivateLinkCreator, root.FigshareApi.PrivateLinkResponse, root.FigshareApi.PublicFile, root.FigshareApi.Resource);
  }
}(this, function(ApiClient, AccountReport, Article, ArticleComplete, ArticleCompletePrivate, ArticleConfidentiality, ArticleCreate, ArticleDOI, ArticleEmbargo, ArticleEmbargoUpdater, ArticleHandle, ArticleSearch, ArticleUpdate, ArticleVersions, ArticleWithProject, Author, AuthorsCreator, CategoriesCreator, Category, ConfidentialityCreator, ErrorMessage, FileCreator, FileId, Location, LocationWarnings, LocationWarningsUpdate, PrivateArticleSearch, PrivateFile, PrivateLink, PrivateLinkCreator, PrivateLinkResponse, PublicFile, Resource) {
  'use strict';

  /**
   * Articles service.
   * @module api/ArticlesApi
   * @version 2.0.0
   */

  /**
   * Constructs a new ArticlesApi. 
   * @alias module:api/ArticlesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the accountArticleReport operation.
     * @callback module:api/ArticlesApi~accountArticleReportCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/AccountReport>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Account Article Report
     * Return status on all reports generated for the account from the oauth credentials
     * @param {Object} opts Optional parameters
     * @param {Number} opts.groupId A group ID to filter by
     * @param {module:api/ArticlesApi~accountArticleReportCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/AccountReport>}
     */
    this.accountArticleReport = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'group_id': opts['groupId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [AccountReport];

      return this.apiClient.callApi(
        '/account/articles/export', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountArticleReportGenerate operation.
     * @callback module:api/ArticlesApi~accountArticleReportGenerateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AccountReport} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Initiate a new Report
     * Initiate a new Article Report for this Account. There is a limit of 1 report per day.
     * @param {module:api/ArticlesApi~accountArticleReportGenerateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AccountReport}
     */
    this.accountArticleReportGenerate = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = AccountReport;

      return this.apiClient.callApi(
        '/account/articles/export', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleDetails operation.
     * @callback module:api/ArticlesApi~articleDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleComplete} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * View article details
     * View an article
     * @param {Number} articleId Article Unique identifier
     * @param {module:api/ArticlesApi~articleDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleComplete}
     */
    this.articleDetails = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleDetails");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleComplete;

      return this.apiClient.callApi(
        '/articles/{article_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleFileDetails operation.
     * @callback module:api/ArticlesApi~articleFileDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PublicFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Article file details
     * File by id
     * @param {Number} articleId Article Unique identifier
     * @param {Number} fileId File Unique identifier
     * @param {module:api/ArticlesApi~articleFileDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PublicFile}
     */
    this.articleFileDetails = function(articleId, fileId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleFileDetails");
      }

      // verify the required parameter 'fileId' is set
      if (fileId === undefined || fileId === null) {
        throw new Error("Missing the required parameter 'fileId' when calling articleFileDetails");
      }


      var pathParams = {
        'article_id': articleId,
        'file_id': fileId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PublicFile;

      return this.apiClient.callApi(
        '/articles/{article_id}/files/{file_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleFiles operation.
     * @callback module:api/ArticlesApi~articleFilesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/PublicFile>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List article files
     * Files list for article
     * @param {Number} articleId Article Unique identifier
     * @param {module:api/ArticlesApi~articleFilesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/PublicFile>}
     */
    this.articleFiles = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleFiles");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [PublicFile];

      return this.apiClient.callApi(
        '/articles/{article_id}/files', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleVersionConfidentiality operation.
     * @callback module:api/ArticlesApi~articleVersionConfidentialityCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleConfidentiality} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Article Confidentiality for article version
     * Confidentiality for article version. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
     * @param {Number} articleId Article Unique identifier
     * @param {Number} vNumber Version Number
     * @param {module:api/ArticlesApi~articleVersionConfidentialityCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleConfidentiality}
     */
    this.articleVersionConfidentiality = function(articleId, vNumber, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleVersionConfidentiality");
      }

      // verify the required parameter 'vNumber' is set
      if (vNumber === undefined || vNumber === null) {
        throw new Error("Missing the required parameter 'vNumber' when calling articleVersionConfidentiality");
      }


      var pathParams = {
        'article_id': articleId,
        'v_number': vNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleConfidentiality;

      return this.apiClient.callApi(
        '/articles/{article_id}/versions/{v_number}/confidentiality', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleVersionDetails operation.
     * @callback module:api/ArticlesApi~articleVersionDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleComplete} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Article details for version
     * Article with specified version
     * @param {Number} articleId Article Unique identifier
     * @param {Number} vNumber Article Version Number
     * @param {module:api/ArticlesApi~articleVersionDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleComplete}
     */
    this.articleVersionDetails = function(articleId, vNumber, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleVersionDetails");
      }

      // verify the required parameter 'vNumber' is set
      if (vNumber === undefined || vNumber === null) {
        throw new Error("Missing the required parameter 'vNumber' when calling articleVersionDetails");
      }


      var pathParams = {
        'article_id': articleId,
        'v_number': vNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleComplete;

      return this.apiClient.callApi(
        '/articles/{article_id}/versions/{v_number}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleVersionEmbargo operation.
     * @callback module:api/ArticlesApi~articleVersionEmbargoCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleEmbargo} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Article Embargo for article version
     * Embargo for article version
     * @param {Number} articleId Article Unique identifier
     * @param {Number} vNumber Version Number
     * @param {module:api/ArticlesApi~articleVersionEmbargoCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleEmbargo}
     */
    this.articleVersionEmbargo = function(articleId, vNumber, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleVersionEmbargo");
      }

      // verify the required parameter 'vNumber' is set
      if (vNumber === undefined || vNumber === null) {
        throw new Error("Missing the required parameter 'vNumber' when calling articleVersionEmbargo");
      }


      var pathParams = {
        'article_id': articleId,
        'v_number': vNumber
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleEmbargo;

      return this.apiClient.callApi(
        '/articles/{article_id}/versions/{v_number}/embargo', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleVersionUpdate operation.
     * @callback module:api/ArticlesApi~articleVersionUpdateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LocationWarningsUpdate} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update article version
     * Updating an article version by passing body parameters; request can also be made with the PATCH method.
     * @param {Number} articleId Article unique identifier
     * @param {Number} versionId Article version identifier
     * @param {module:model/ArticleUpdate} article Article description
     * @param {module:api/ArticlesApi~articleVersionUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LocationWarningsUpdate}
     */
    this.articleVersionUpdate = function(articleId, versionId, article, callback) {
      var postBody = article;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleVersionUpdate");
      }

      // verify the required parameter 'versionId' is set
      if (versionId === undefined || versionId === null) {
        throw new Error("Missing the required parameter 'versionId' when calling articleVersionUpdate");
      }

      // verify the required parameter 'article' is set
      if (article === undefined || article === null) {
        throw new Error("Missing the required parameter 'article' when calling articleVersionUpdate");
      }


      var pathParams = {
        'article_id': articleId,
        'version_id': versionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = LocationWarningsUpdate;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/versions/{version_id}/', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleVersionUpdateThumb operation.
     * @callback module:api/ArticlesApi~articleVersionUpdateThumbCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update article version thumbnail
     * For a given public article version update the article thumbnail by choosing one of the associated files
     * @param {Number} articleId Article unique identifier
     * @param {Number} versionId Article version identifier
     * @param {module:model/FileId} fileId File ID
     * @param {module:api/ArticlesApi~articleVersionUpdateThumbCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.articleVersionUpdateThumb = function(articleId, versionId, fileId, callback) {
      var postBody = fileId;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleVersionUpdateThumb");
      }

      // verify the required parameter 'versionId' is set
      if (versionId === undefined || versionId === null) {
        throw new Error("Missing the required parameter 'versionId' when calling articleVersionUpdateThumb");
      }

      // verify the required parameter 'fileId' is set
      if (fileId === undefined || fileId === null) {
        throw new Error("Missing the required parameter 'fileId' when calling articleVersionUpdateThumb");
      }


      var pathParams = {
        'article_id': articleId,
        'version_id': versionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/versions/{version_id}/update_thumb', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articleVersions operation.
     * @callback module:api/ArticlesApi~articleVersionsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ArticleVersions>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List article versions
     * List public article versions
     * @param {Number} articleId Article Unique identifier
     * @param {module:api/ArticlesApi~articleVersionsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ArticleVersions>}
     */
    this.articleVersions = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling articleVersions");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ArticleVersions];

      return this.apiClient.callApi(
        '/articles/{article_id}/versions', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articlesList operation.
     * @callback module:api/ArticlesApi~articlesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Article>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Articles
     * Returns a list of public articles
     * @param {Object} opts Optional parameters
     * @param {String} opts.xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
     * @param {Number} opts.page Page number. Used for pagination with page_size
     * @param {Number} opts.pageSize The number of results included on a page. Used for pagination with page (default to 10)
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:model/String} opts.order The field by which to order. Default varies by endpoint/resource. (default to published_date)
     * @param {module:model/String} opts.orderDirection  (default to desc)
     * @param {Number} opts.institution only return articles from this institution
     * @param {String} opts.publishedSince Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
     * @param {String} opts.modifiedSince Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
     * @param {Number} opts.group only return articles from this group
     * @param {String} opts.resourceDoi only return articles with this resource_doi
     * @param {Number} opts.itemType Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model
     * @param {String} opts.doi only return articles with this doi
     * @param {String} opts.handle only return articles with this handle
     * @param {module:api/ArticlesApi~articlesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Article>}
     */
    this.articlesList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'page': opts['page'],
        'page_size': opts['pageSize'],
        'limit': opts['limit'],
        'offset': opts['offset'],
        'order': opts['order'],
        'order_direction': opts['orderDirection'],
        'institution': opts['institution'],
        'published_since': opts['publishedSince'],
        'modified_since': opts['modifiedSince'],
        'group': opts['group'],
        'resource_doi': opts['resourceDoi'],
        'item_type': opts['itemType'],
        'doi': opts['doi'],
        'handle': opts['handle'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'X-Cursor': opts['xCursor']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Article];

      return this.apiClient.callApi(
        '/articles', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the articlesSearch operation.
     * @callback module:api/ArticlesApi~articlesSearchCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ArticleWithProject>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Articles Search
     * Returns a list of public articles, filtered by the search parameters
     * @param {Object} opts Optional parameters
     * @param {String} opts.xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
     * @param {module:model/ArticleSearch} opts.search Search Parameters
     * @param {module:api/ArticlesApi~articlesSearchCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ArticleWithProject>}
     */
    this.articlesSearch = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['search'];


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'X-Cursor': opts['xCursor']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ArticleWithProject];

      return this.apiClient.callApi(
        '/articles/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleAuthorDelete operation.
     * @callback module:api/ArticlesApi~privateArticleAuthorDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete article author
     * De-associate author from article
     * @param {Number} articleId Article unique identifier
     * @param {Number} authorId Article Author unique identifier
     * @param {module:api/ArticlesApi~privateArticleAuthorDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleAuthorDelete = function(articleId, authorId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleAuthorDelete");
      }

      // verify the required parameter 'authorId' is set
      if (authorId === undefined || authorId === null) {
        throw new Error("Missing the required parameter 'authorId' when calling privateArticleAuthorDelete");
      }


      var pathParams = {
        'article_id': articleId,
        'author_id': authorId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/authors/{author_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleAuthorsAdd operation.
     * @callback module:api/ArticlesApi~privateArticleAuthorsAddCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add article authors
     * Associate new authors with the article. This will add new authors to the list of already associated authors
     * @param {Number} articleId Article unique identifier
     * @param {module:model/AuthorsCreator} authors Authors description
     * @param {module:api/ArticlesApi~privateArticleAuthorsAddCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleAuthorsAdd = function(articleId, authors, callback) {
      var postBody = authors;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleAuthorsAdd");
      }

      // verify the required parameter 'authors' is set
      if (authors === undefined || authors === null) {
        throw new Error("Missing the required parameter 'authors' when calling privateArticleAuthorsAdd");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/authors', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleAuthorsList operation.
     * @callback module:api/ArticlesApi~privateArticleAuthorsListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Author>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List article authors
     * List article authors
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleAuthorsListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Author>}
     */
    this.privateArticleAuthorsList = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleAuthorsList");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Author];

      return this.apiClient.callApi(
        '/account/articles/{article_id}/authors', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleAuthorsReplace operation.
     * @callback module:api/ArticlesApi~privateArticleAuthorsReplaceCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Replace article authors
     * Associate new authors with the article. This will remove all already associated authors and add these new ones
     * @param {Number} articleId Article unique identifier
     * @param {module:model/AuthorsCreator} authors Authors description
     * @param {module:api/ArticlesApi~privateArticleAuthorsReplaceCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleAuthorsReplace = function(articleId, authors, callback) {
      var postBody = authors;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleAuthorsReplace");
      }

      // verify the required parameter 'authors' is set
      if (authors === undefined || authors === null) {
        throw new Error("Missing the required parameter 'authors' when calling privateArticleAuthorsReplace");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/authors', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleCategoriesAdd operation.
     * @callback module:api/ArticlesApi~privateArticleCategoriesAddCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add article categories
     * Associate new categories with the article. This will add new categories to the list of already associated categories
     * @param {Number} articleId Article unique identifier
     * @param {module:model/CategoriesCreator} categories 
     * @param {module:api/ArticlesApi~privateArticleCategoriesAddCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleCategoriesAdd = function(articleId, categories, callback) {
      var postBody = categories;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleCategoriesAdd");
      }

      // verify the required parameter 'categories' is set
      if (categories === undefined || categories === null) {
        throw new Error("Missing the required parameter 'categories' when calling privateArticleCategoriesAdd");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/categories', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleCategoriesList operation.
     * @callback module:api/ArticlesApi~privateArticleCategoriesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Category>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List article categories
     * List article categories
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleCategoriesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Category>}
     */
    this.privateArticleCategoriesList = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleCategoriesList");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Category];

      return this.apiClient.callApi(
        '/account/articles/{article_id}/categories', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleCategoriesReplace operation.
     * @callback module:api/ArticlesApi~privateArticleCategoriesReplaceCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Replace article categories
     * Associate new categories with the article. This will remove all already associated categories and add these new ones
     * @param {Number} articleId Article unique identifier
     * @param {module:model/CategoriesCreator} categories 
     * @param {module:api/ArticlesApi~privateArticleCategoriesReplaceCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleCategoriesReplace = function(articleId, categories, callback) {
      var postBody = categories;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleCategoriesReplace");
      }

      // verify the required parameter 'categories' is set
      if (categories === undefined || categories === null) {
        throw new Error("Missing the required parameter 'categories' when calling privateArticleCategoriesReplace");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/categories', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleCategoryDelete operation.
     * @callback module:api/ArticlesApi~privateArticleCategoryDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete article category
     * De-associate category from article
     * @param {Number} articleId Article unique identifier
     * @param {Number} categoryId Category unique identifier
     * @param {module:api/ArticlesApi~privateArticleCategoryDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleCategoryDelete = function(articleId, categoryId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleCategoryDelete");
      }

      // verify the required parameter 'categoryId' is set
      if (categoryId === undefined || categoryId === null) {
        throw new Error("Missing the required parameter 'categoryId' when calling privateArticleCategoryDelete");
      }


      var pathParams = {
        'article_id': articleId,
        'category_id': categoryId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/categories/{category_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleConfidentialityDelete operation.
     * @callback module:api/ArticlesApi~privateArticleConfidentialityDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete article confidentiality
     * Delete confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleConfidentialityDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleConfidentialityDelete = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleConfidentialityDelete");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/confidentiality', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleConfidentialityDetails operation.
     * @callback module:api/ArticlesApi~privateArticleConfidentialityDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleConfidentiality} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Article confidentiality details
     * View confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleConfidentialityDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleConfidentiality}
     */
    this.privateArticleConfidentialityDetails = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleConfidentialityDetails");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleConfidentiality;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/confidentiality', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleConfidentialityUpdate operation.
     * @callback module:api/ArticlesApi~privateArticleConfidentialityUpdateCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update article confidentiality
     * Update confidentiality settings. The confidentiality feature is now deprecated. This has been replaced by the new extended embargo functionality and all items that used to be confidential have now been migrated to items with a permanent embargo on files. All API endpoints related to this functionality will remain for backwards compatibility, but will now be attached to the new extended embargo workflows.
     * @param {Number} articleId Article unique identifier
     * @param {module:model/ConfidentialityCreator} reason 
     * @param {module:api/ArticlesApi~privateArticleConfidentialityUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleConfidentialityUpdate = function(articleId, reason, callback) {
      var postBody = reason;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleConfidentialityUpdate");
      }

      // verify the required parameter 'reason' is set
      if (reason === undefined || reason === null) {
        throw new Error("Missing the required parameter 'reason' when calling privateArticleConfidentialityUpdate");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/confidentiality', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleCreate operation.
     * @callback module:api/ArticlesApi~privateArticleCreateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LocationWarnings} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new Article
     * Create a new Article by sending article information
     * @param {module:model/ArticleCreate} article Article description
     * @param {module:api/ArticlesApi~privateArticleCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LocationWarnings}
     */
    this.privateArticleCreate = function(article, callback) {
      var postBody = article;

      // verify the required parameter 'article' is set
      if (article === undefined || article === null) {
        throw new Error("Missing the required parameter 'article' when calling privateArticleCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = LocationWarnings;

      return this.apiClient.callApi(
        '/account/articles', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleDelete operation.
     * @callback module:api/ArticlesApi~privateArticleDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete article
     * Delete an article
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleDelete = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleDelete");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleDetails operation.
     * @callback module:api/ArticlesApi~privateArticleDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleCompletePrivate} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Article details
     * View a private article
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleCompletePrivate}
     */
    this.privateArticleDetails = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleDetails");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleCompletePrivate;

      return this.apiClient.callApi(
        '/account/articles/{article_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleEmbargoDelete operation.
     * @callback module:api/ArticlesApi~privateArticleEmbargoDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Article Embargo
     * Will lift the embargo for the specified article
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleEmbargoDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleEmbargoDelete = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleEmbargoDelete");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/embargo', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleEmbargoDetails operation.
     * @callback module:api/ArticlesApi~privateArticleEmbargoDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleEmbargo} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Article Embargo Details
     * View a private article embargo details
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleEmbargoDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleEmbargo}
     */
    this.privateArticleEmbargoDetails = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleEmbargoDetails");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleEmbargo;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/embargo', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleEmbargoUpdate operation.
     * @callback module:api/ArticlesApi~privateArticleEmbargoUpdateCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Article Embargo
     * Note: setting an article under whole embargo does not imply that the article will be published when the embargo will expire. You must explicitly call the publish endpoint to enable this functionality.
     * @param {Number} articleId Article unique identifier
     * @param {module:model/ArticleEmbargoUpdater} embargo Embargo description
     * @param {module:api/ArticlesApi~privateArticleEmbargoUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleEmbargoUpdate = function(articleId, embargo, callback) {
      var postBody = embargo;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleEmbargoUpdate");
      }

      // verify the required parameter 'embargo' is set
      if (embargo === undefined || embargo === null) {
        throw new Error("Missing the required parameter 'embargo' when calling privateArticleEmbargoUpdate");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/embargo', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleFile operation.
     * @callback module:api/ArticlesApi~privateArticleFileCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PrivateFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Single File
     * View details of file for specified article
     * @param {Number} articleId Article unique identifier
     * @param {Number} fileId File unique identifier
     * @param {module:api/ArticlesApi~privateArticleFileCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PrivateFile}
     */
    this.privateArticleFile = function(articleId, fileId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleFile");
      }

      // verify the required parameter 'fileId' is set
      if (fileId === undefined || fileId === null) {
        throw new Error("Missing the required parameter 'fileId' when calling privateArticleFile");
      }


      var pathParams = {
        'article_id': articleId,
        'file_id': fileId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PrivateFile;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/files/{file_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleFileDelete operation.
     * @callback module:api/ArticlesApi~privateArticleFileDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * File Delete
     * Complete file upload
     * @param {Number} articleId Article unique identifier
     * @param {Number} fileId File unique identifier
     * @param {module:api/ArticlesApi~privateArticleFileDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleFileDelete = function(articleId, fileId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleFileDelete");
      }

      // verify the required parameter 'fileId' is set
      if (fileId === undefined || fileId === null) {
        throw new Error("Missing the required parameter 'fileId' when calling privateArticleFileDelete");
      }


      var pathParams = {
        'article_id': articleId,
        'file_id': fileId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/files/{file_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleFilesList operation.
     * @callback module:api/ArticlesApi~privateArticleFilesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/PrivateFile>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List article files
     * List private files
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleFilesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/PrivateFile>}
     */
    this.privateArticleFilesList = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleFilesList");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [PrivateFile];

      return this.apiClient.callApi(
        '/account/articles/{article_id}/files', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticlePrivateLink operation.
     * @callback module:api/ArticlesApi~privateArticlePrivateLinkCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/PrivateLink>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List private links
     * List private links
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticlePrivateLinkCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/PrivateLink>}
     */
    this.privateArticlePrivateLink = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticlePrivateLink");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [PrivateLink];

      return this.apiClient.callApi(
        '/account/articles/{article_id}/private_links', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticlePrivateLinkCreate operation.
     * @callback module:api/ArticlesApi~privateArticlePrivateLinkCreateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PrivateLinkResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create private link
     * Create new private link for this article
     * @param {Number} articleId Article unique identifier
     * @param {Object} opts Optional parameters
     * @param {module:model/PrivateLinkCreator} opts.privateLink 
     * @param {module:api/ArticlesApi~privateArticlePrivateLinkCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PrivateLinkResponse}
     */
    this.privateArticlePrivateLinkCreate = function(articleId, opts, callback) {
      opts = opts || {};
      var postBody = opts['privateLink'];

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticlePrivateLinkCreate");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PrivateLinkResponse;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/private_links', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticlePrivateLinkDelete operation.
     * @callback module:api/ArticlesApi~privateArticlePrivateLinkDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Disable private link
     * Disable/delete private link for this article
     * @param {Number} articleId Article unique identifier
     * @param {String} linkId Private link token
     * @param {module:api/ArticlesApi~privateArticlePrivateLinkDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticlePrivateLinkDelete = function(articleId, linkId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticlePrivateLinkDelete");
      }

      // verify the required parameter 'linkId' is set
      if (linkId === undefined || linkId === null) {
        throw new Error("Missing the required parameter 'linkId' when calling privateArticlePrivateLinkDelete");
      }


      var pathParams = {
        'article_id': articleId,
        'link_id': linkId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/private_links/{link_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticlePrivateLinkUpdate operation.
     * @callback module:api/ArticlesApi~privateArticlePrivateLinkUpdateCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update private link
     * Update existing private link for this article
     * @param {Number} articleId Article unique identifier
     * @param {String} linkId Private link token
     * @param {Object} opts Optional parameters
     * @param {module:model/PrivateLinkCreator} opts.privateLink 
     * @param {module:api/ArticlesApi~privateArticlePrivateLinkUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticlePrivateLinkUpdate = function(articleId, linkId, opts, callback) {
      opts = opts || {};
      var postBody = opts['privateLink'];

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticlePrivateLinkUpdate");
      }

      // verify the required parameter 'linkId' is set
      if (linkId === undefined || linkId === null) {
        throw new Error("Missing the required parameter 'linkId' when calling privateArticlePrivateLinkUpdate");
      }


      var pathParams = {
        'article_id': articleId,
        'link_id': linkId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/private_links/{link_id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticlePublish operation.
     * @callback module:api/ArticlesApi~privateArticlePublishCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Location} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Article Publish
     * - If the whole article is under embargo, it will not be published immediately, but when the embargo expires or is lifted. - When an article is published, a new public version will be generated. Any further updates to the article will affect the private article data. In order to make these changes publicly visible, an explicit publish operation is needed.
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticlePublishCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Location}
     */
    this.privateArticlePublish = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticlePublish");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Location;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/publish', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleReserveDoi operation.
     * @callback module:api/ArticlesApi~privateArticleReserveDoiCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleDOI} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Article Reserve DOI
     * Reserve DOI for article
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleReserveDoiCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleDOI}
     */
    this.privateArticleReserveDoi = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleReserveDoi");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleDOI;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/reserve_doi', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleReserveHandle operation.
     * @callback module:api/ArticlesApi~privateArticleReserveHandleCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ArticleHandle} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Article Reserve Handle
     * Reserve Handle for article
     * @param {Number} articleId Article unique identifier
     * @param {module:api/ArticlesApi~privateArticleReserveHandleCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ArticleHandle}
     */
    this.privateArticleReserveHandle = function(articleId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleReserveHandle");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ArticleHandle;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/reserve_handle', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleResource operation.
     * @callback module:api/ArticlesApi~privateArticleResourceCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Location} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Article Resource
     * Edit article resource data.
     * @param {Number} articleId Article unique identifier
     * @param {module:model/Resource} resource Resource data
     * @param {module:api/ArticlesApi~privateArticleResourceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Location}
     */
    this.privateArticleResource = function(articleId, resource, callback) {
      var postBody = resource;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleResource");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling privateArticleResource");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Location;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/resource', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleUpdate operation.
     * @callback module:api/ArticlesApi~privateArticleUpdateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LocationWarningsUpdate} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update article
     * Updating an article by passing body parameters; request can also be made with the PATCH method.
     * @param {Number} articleId Article unique identifier
     * @param {module:model/ArticleUpdate} article Article description
     * @param {module:api/ArticlesApi~privateArticleUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LocationWarningsUpdate}
     */
    this.privateArticleUpdate = function(articleId, article, callback) {
      var postBody = article;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleUpdate");
      }

      // verify the required parameter 'article' is set
      if (article === undefined || article === null) {
        throw new Error("Missing the required parameter 'article' when calling privateArticleUpdate");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = LocationWarningsUpdate;

      return this.apiClient.callApi(
        '/account/articles/{article_id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleUploadComplete operation.
     * @callback module:api/ArticlesApi~privateArticleUploadCompleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Complete Upload
     * Complete file upload
     * @param {Number} articleId Article unique identifier
     * @param {Number} fileId File unique identifier
     * @param {module:api/ArticlesApi~privateArticleUploadCompleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateArticleUploadComplete = function(articleId, fileId, callback) {
      var postBody = null;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleUploadComplete");
      }

      // verify the required parameter 'fileId' is set
      if (fileId === undefined || fileId === null) {
        throw new Error("Missing the required parameter 'fileId' when calling privateArticleUploadComplete");
      }


      var pathParams = {
        'article_id': articleId,
        'file_id': fileId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/files/{file_id}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticleUploadInitiate operation.
     * @callback module:api/ArticlesApi~privateArticleUploadInitiateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Location} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Initiate Upload
     * Initiate a new file upload within the article. Either use the link property to point to an existing file that resides elsewhere and will not be uploaded to Figshare or use the other 3 parameters (md5, name, size).
     * @param {Number} articleId Article unique identifier
     * @param {module:model/FileCreator} file 
     * @param {module:api/ArticlesApi~privateArticleUploadInitiateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Location}
     */
    this.privateArticleUploadInitiate = function(articleId, file, callback) {
      var postBody = file;

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateArticleUploadInitiate");
      }

      // verify the required parameter 'file' is set
      if (file === undefined || file === null) {
        throw new Error("Missing the required parameter 'file' when calling privateArticleUploadInitiate");
      }


      var pathParams = {
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Location;

      return this.apiClient.callApi(
        '/account/articles/{article_id}/files', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticlesList operation.
     * @callback module:api/ArticlesApi~privateArticlesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Article>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Articles
     * Get Own Articles
     * @param {Object} opts Optional parameters
     * @param {Number} opts.page Page number. Used for pagination with page_size
     * @param {Number} opts.pageSize The number of results included on a page. Used for pagination with page (default to 10)
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:api/ArticlesApi~privateArticlesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Article>}
     */
    this.privateArticlesList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'page': opts['page'],
        'page_size': opts['pageSize'],
        'limit': opts['limit'],
        'offset': opts['offset'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Article];

      return this.apiClient.callApi(
        '/account/articles', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateArticlesSearch operation.
     * @callback module:api/ArticlesApi~privateArticlesSearchCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ArticleWithProject>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Articles search
     * Returns a list of private articles filtered by the search parameters
     * @param {module:model/PrivateArticleSearch} search Search Parameters
     * @param {module:api/ArticlesApi~privateArticlesSearchCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ArticleWithProject>}
     */
    this.privateArticlesSearch = function(search, callback) {
      var postBody = search;

      // verify the required parameter 'search' is set
      if (search === undefined || search === null) {
        throw new Error("Missing the required parameter 'search' when calling privateArticlesSearch");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ArticleWithProject];

      return this.apiClient.callApi(
        '/account/articles/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
