/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Author', 'model/AuthorComplete', 'model/ErrorMessage', 'model/PrivateAuthorsSearch'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Author'), require('../model/AuthorComplete'), require('../model/ErrorMessage'), require('../model/PrivateAuthorsSearch'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.AuthorsApi = factory(root.FigshareApi.ApiClient, root.FigshareApi.Author, root.FigshareApi.AuthorComplete, root.FigshareApi.ErrorMessage, root.FigshareApi.PrivateAuthorsSearch);
  }
}(this, function(ApiClient, Author, AuthorComplete, ErrorMessage, PrivateAuthorsSearch) {
  'use strict';

  /**
   * Authors service.
   * @module api/AuthorsApi
   * @version 2.0.0
   */

  /**
   * Constructs a new AuthorsApi. 
   * @alias module:api/AuthorsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the privateAuthorDetails operation.
     * @callback module:api/AuthorsApi~privateAuthorDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AuthorComplete} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Author details
     * View author details
     * @param {Number} authorId Author unique identifier
     * @param {module:api/AuthorsApi~privateAuthorDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AuthorComplete}
     */
    this.privateAuthorDetails = function(authorId, callback) {
      var postBody = null;

      // verify the required parameter 'authorId' is set
      if (authorId === undefined || authorId === null) {
        throw new Error("Missing the required parameter 'authorId' when calling privateAuthorDetails");
      }


      var pathParams = {
        'author_id': authorId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = AuthorComplete;

      return this.apiClient.callApi(
        '/account/authors/{author_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateAuthorsSearch operation.
     * @callback module:api/AuthorsApi~privateAuthorsSearchCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Author>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search Authors
     * Search for authors
     * @param {Object} opts Optional parameters
     * @param {module:model/PrivateAuthorsSearch} opts.search Search Parameters
     * @param {module:api/AuthorsApi~privateAuthorsSearchCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Author>}
     */
    this.privateAuthorsSearch = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['search'];


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Author];

      return this.apiClient.callApi(
        '/account/authors/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
