/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Article', 'model/ArticlesCreator', 'model/Author', 'model/AuthorsCreator', 'model/CategoriesCreator', 'model/Category', 'model/Collection', 'model/CollectionComplete', 'model/CollectionCompletePrivate', 'model/CollectionCreate', 'model/CollectionDOI', 'model/CollectionHandle', 'model/CollectionPrivateLinkCreator', 'model/CollectionSearch', 'model/CollectionUpdate', 'model/CollectionVersions', 'model/ErrorMessage', 'model/Location', 'model/LocationWarnings', 'model/LocationWarningsUpdate', 'model/PrivateCollectionSearch', 'model/PrivateLink', 'model/PrivateLinkResponse', 'model/Resource'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Article'), require('../model/ArticlesCreator'), require('../model/Author'), require('../model/AuthorsCreator'), require('../model/CategoriesCreator'), require('../model/Category'), require('../model/Collection'), require('../model/CollectionComplete'), require('../model/CollectionCompletePrivate'), require('../model/CollectionCreate'), require('../model/CollectionDOI'), require('../model/CollectionHandle'), require('../model/CollectionPrivateLinkCreator'), require('../model/CollectionSearch'), require('../model/CollectionUpdate'), require('../model/CollectionVersions'), require('../model/ErrorMessage'), require('../model/Location'), require('../model/LocationWarnings'), require('../model/LocationWarningsUpdate'), require('../model/PrivateCollectionSearch'), require('../model/PrivateLink'), require('../model/PrivateLinkResponse'), require('../model/Resource'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.CollectionsApi = factory(root.FigshareApi.ApiClient, root.FigshareApi.Article, root.FigshareApi.ArticlesCreator, root.FigshareApi.Author, root.FigshareApi.AuthorsCreator, root.FigshareApi.CategoriesCreator, root.FigshareApi.Category, root.FigshareApi.Collection, root.FigshareApi.CollectionComplete, root.FigshareApi.CollectionCompletePrivate, root.FigshareApi.CollectionCreate, root.FigshareApi.CollectionDOI, root.FigshareApi.CollectionHandle, root.FigshareApi.CollectionPrivateLinkCreator, root.FigshareApi.CollectionSearch, root.FigshareApi.CollectionUpdate, root.FigshareApi.CollectionVersions, root.FigshareApi.ErrorMessage, root.FigshareApi.Location, root.FigshareApi.LocationWarnings, root.FigshareApi.LocationWarningsUpdate, root.FigshareApi.PrivateCollectionSearch, root.FigshareApi.PrivateLink, root.FigshareApi.PrivateLinkResponse, root.FigshareApi.Resource);
  }
}(this, function(ApiClient, Article, ArticlesCreator, Author, AuthorsCreator, CategoriesCreator, Category, Collection, CollectionComplete, CollectionCompletePrivate, CollectionCreate, CollectionDOI, CollectionHandle, CollectionPrivateLinkCreator, CollectionSearch, CollectionUpdate, CollectionVersions, ErrorMessage, Location, LocationWarnings, LocationWarningsUpdate, PrivateCollectionSearch, PrivateLink, PrivateLinkResponse, Resource) {
  'use strict';

  /**
   * Collections service.
   * @module api/CollectionsApi
   * @version 2.0.0
   */

  /**
   * Constructs a new CollectionsApi. 
   * @alias module:api/CollectionsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the collectionArticles operation.
     * @callback module:api/CollectionsApi~collectionArticlesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Article>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Collection Articles
     * Returns a list of public collection articles
     * @param {Number} collectionId Collection Unique identifier
     * @param {Object} opts Optional parameters
     * @param {Number} opts.page Page number. Used for pagination with page_size
     * @param {Number} opts.pageSize The number of results included on a page. Used for pagination with page (default to 10)
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:api/CollectionsApi~collectionArticlesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Article>}
     */
    this.collectionArticles = function(collectionId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling collectionArticles");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
        'page': opts['page'],
        'page_size': opts['pageSize'],
        'limit': opts['limit'],
        'offset': opts['offset'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Article];

      return this.apiClient.callApi(
        '/collections/{collection_id}/articles', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the collectionDetails operation.
     * @callback module:api/CollectionsApi~collectionDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CollectionComplete} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Collection details
     * View a collection
     * @param {Number} collectionId Collection Unique identifier
     * @param {module:api/CollectionsApi~collectionDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CollectionComplete}
     */
    this.collectionDetails = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling collectionDetails");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = CollectionComplete;

      return this.apiClient.callApi(
        '/collections/{collection_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the collectionVersionDetails operation.
     * @callback module:api/CollectionsApi~collectionVersionDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CollectionComplete} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Collection Version details
     * View details for a certain version of a collection
     * @param {Number} collectionId Collection Unique identifier
     * @param {Number} versionId Version Number
     * @param {module:api/CollectionsApi~collectionVersionDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CollectionComplete}
     */
    this.collectionVersionDetails = function(collectionId, versionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling collectionVersionDetails");
      }

      // verify the required parameter 'versionId' is set
      if (versionId === undefined || versionId === null) {
        throw new Error("Missing the required parameter 'versionId' when calling collectionVersionDetails");
      }


      var pathParams = {
        'collection_id': collectionId,
        'version_id': versionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = CollectionComplete;

      return this.apiClient.callApi(
        '/collections/{collection_id}/versions/{version_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the collectionVersions operation.
     * @callback module:api/CollectionsApi~collectionVersionsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/CollectionVersions>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Collection Versions list
     * Returns a list of public collection Versions
     * @param {Number} collectionId Collection Unique identifier
     * @param {module:api/CollectionsApi~collectionVersionsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/CollectionVersions>}
     */
    this.collectionVersions = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling collectionVersions");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [CollectionVersions];

      return this.apiClient.callApi(
        '/collections/{collection_id}/versions', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the collectionsList operation.
     * @callback module:api/CollectionsApi~collectionsListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Collection>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Collections
     * Returns a list of public collections
     * @param {Object} opts Optional parameters
     * @param {String} opts.xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
     * @param {Number} opts.page Page number. Used for pagination with page_size
     * @param {Number} opts.pageSize The number of results included on a page. Used for pagination with page (default to 10)
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:model/String} opts.order The field by which to order. Default varies by endpoint/resource. (default to published_date)
     * @param {module:model/String} opts.orderDirection  (default to desc)
     * @param {Number} opts.institution only return collections from this institution
     * @param {String} opts.publishedSince Filter by collection publishing date. Will only return collections published after the date. date(ISO 8601) YYYY-MM-DD
     * @param {String} opts.modifiedSince Filter by collection modified date. Will only return collections published after the date. date(ISO 8601) YYYY-MM-DD
     * @param {Number} opts.group only return collections from this group
     * @param {String} opts.resourceDoi only return collections with this resource_doi
     * @param {String} opts.doi only return collections with this doi
     * @param {String} opts.handle only return collections with this handle
     * @param {module:api/CollectionsApi~collectionsListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Collection>}
     */
    this.collectionsList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'page': opts['page'],
        'page_size': opts['pageSize'],
        'limit': opts['limit'],
        'offset': opts['offset'],
        'order': opts['order'],
        'order_direction': opts['orderDirection'],
        'institution': opts['institution'],
        'published_since': opts['publishedSince'],
        'modified_since': opts['modifiedSince'],
        'group': opts['group'],
        'resource_doi': opts['resourceDoi'],
        'doi': opts['doi'],
        'handle': opts['handle'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'X-Cursor': opts['xCursor']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Collection];

      return this.apiClient.callApi(
        '/collections', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the collectionsSearch operation.
     * @callback module:api/CollectionsApi~collectionsSearchCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Collection>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Collections Search
     * Returns a list of public collections
     * @param {Object} opts Optional parameters
     * @param {String} opts.xCursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.
     * @param {module:model/CollectionSearch} opts.search Search Parameters
     * @param {module:api/CollectionsApi~collectionsSearchCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Collection>}
     */
    this.collectionsSearch = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['search'];


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'X-Cursor': opts['xCursor']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Collection];

      return this.apiClient.callApi(
        '/collections/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionArticleDelete operation.
     * @callback module:api/CollectionsApi~privateCollectionArticleDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete collection article
     * De-associate article from collection
     * @param {Number} collectionId Collection unique identifier
     * @param {Number} articleId Collection article unique identifier
     * @param {module:api/CollectionsApi~privateCollectionArticleDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionArticleDelete = function(collectionId, articleId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionArticleDelete");
      }

      // verify the required parameter 'articleId' is set
      if (articleId === undefined || articleId === null) {
        throw new Error("Missing the required parameter 'articleId' when calling privateCollectionArticleDelete");
      }


      var pathParams = {
        'collection_id': collectionId,
        'article_id': articleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/articles/{article_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionArticlesAdd operation.
     * @callback module:api/CollectionsApi~privateCollectionArticlesAddCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Location} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add collection articles
     * Associate new articles with the collection. This will add new articles to the list of already associated articles
     * @param {Number} collectionId Collection unique identifier
     * @param {module:model/ArticlesCreator} articles Articles list
     * @param {module:api/CollectionsApi~privateCollectionArticlesAddCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Location}
     */
    this.privateCollectionArticlesAdd = function(collectionId, articles, callback) {
      var postBody = articles;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionArticlesAdd");
      }

      // verify the required parameter 'articles' is set
      if (articles === undefined || articles === null) {
        throw new Error("Missing the required parameter 'articles' when calling privateCollectionArticlesAdd");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Location;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/articles', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionArticlesList operation.
     * @callback module:api/CollectionsApi~privateCollectionArticlesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Article>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List collection articles
     * List collection articles
     * @param {Number} collectionId Collection unique identifier
     * @param {Object} opts Optional parameters
     * @param {Number} opts.page Page number. Used for pagination with page_size
     * @param {Number} opts.pageSize The number of results included on a page. Used for pagination with page (default to 10)
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:api/CollectionsApi~privateCollectionArticlesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Article>}
     */
    this.privateCollectionArticlesList = function(collectionId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionArticlesList");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
        'page': opts['page'],
        'page_size': opts['pageSize'],
        'limit': opts['limit'],
        'offset': opts['offset'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Article];

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/articles', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionArticlesReplace operation.
     * @callback module:api/CollectionsApi~privateCollectionArticlesReplaceCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Replace collection articles
     * Associate new articles with the collection. This will remove all already associated articles and add these new ones
     * @param {Number} collectionId Collection unique identifier
     * @param {module:model/ArticlesCreator} articles Articles List
     * @param {module:api/CollectionsApi~privateCollectionArticlesReplaceCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionArticlesReplace = function(collectionId, articles, callback) {
      var postBody = articles;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionArticlesReplace");
      }

      // verify the required parameter 'articles' is set
      if (articles === undefined || articles === null) {
        throw new Error("Missing the required parameter 'articles' when calling privateCollectionArticlesReplace");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/articles', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionAuthorDelete operation.
     * @callback module:api/CollectionsApi~privateCollectionAuthorDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete collection author
     * Delete collection author
     * @param {Number} collectionId Collection unique identifier
     * @param {Number} authorId Collection Author unique identifier
     * @param {module:api/CollectionsApi~privateCollectionAuthorDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionAuthorDelete = function(collectionId, authorId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionAuthorDelete");
      }

      // verify the required parameter 'authorId' is set
      if (authorId === undefined || authorId === null) {
        throw new Error("Missing the required parameter 'authorId' when calling privateCollectionAuthorDelete");
      }


      var pathParams = {
        'collection_id': collectionId,
        'author_id': authorId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/authors/{author_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionAuthorsAdd operation.
     * @callback module:api/CollectionsApi~privateCollectionAuthorsAddCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Location} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add collection authors
     * Associate new authors with the collection. This will add new authors to the list of already associated authors
     * @param {Number} collectionId Collection unique identifier
     * @param {module:model/AuthorsCreator} authors List of authors
     * @param {module:api/CollectionsApi~privateCollectionAuthorsAddCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Location}
     */
    this.privateCollectionAuthorsAdd = function(collectionId, authors, callback) {
      var postBody = authors;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionAuthorsAdd");
      }

      // verify the required parameter 'authors' is set
      if (authors === undefined || authors === null) {
        throw new Error("Missing the required parameter 'authors' when calling privateCollectionAuthorsAdd");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Location;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/authors', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionAuthorsList operation.
     * @callback module:api/CollectionsApi~privateCollectionAuthorsListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Author>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List collection authors
     * List collection authors
     * @param {Number} collectionId Collection unique identifier
     * @param {module:api/CollectionsApi~privateCollectionAuthorsListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Author>}
     */
    this.privateCollectionAuthorsList = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionAuthorsList");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Author];

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/authors', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionAuthorsReplace operation.
     * @callback module:api/CollectionsApi~privateCollectionAuthorsReplaceCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Replace collection authors
     * Associate new authors with the collection. This will remove all already associated authors and add these new ones
     * @param {Number} collectionId Collection unique identifier
     * @param {module:model/AuthorsCreator} authors List of authors
     * @param {module:api/CollectionsApi~privateCollectionAuthorsReplaceCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionAuthorsReplace = function(collectionId, authors, callback) {
      var postBody = authors;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionAuthorsReplace");
      }

      // verify the required parameter 'authors' is set
      if (authors === undefined || authors === null) {
        throw new Error("Missing the required parameter 'authors' when calling privateCollectionAuthorsReplace");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/authors', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionCategoriesAdd operation.
     * @callback module:api/CollectionsApi~privateCollectionCategoriesAddCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Location} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add collection categories
     * Associate new categories with the collection. This will add new categories to the list of already associated categories
     * @param {Number} collectionId Collection unique identifier
     * @param {module:model/CategoriesCreator} categories Categories list
     * @param {module:api/CollectionsApi~privateCollectionCategoriesAddCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Location}
     */
    this.privateCollectionCategoriesAdd = function(collectionId, categories, callback) {
      var postBody = categories;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionCategoriesAdd");
      }

      // verify the required parameter 'categories' is set
      if (categories === undefined || categories === null) {
        throw new Error("Missing the required parameter 'categories' when calling privateCollectionCategoriesAdd");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Location;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/categories', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionCategoriesList operation.
     * @callback module:api/CollectionsApi~privateCollectionCategoriesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Category>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List collection categories
     * List collection categories
     * @param {Number} collectionId Collection unique identifier
     * @param {module:api/CollectionsApi~privateCollectionCategoriesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Category>}
     */
    this.privateCollectionCategoriesList = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionCategoriesList");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Category];

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/categories', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionCategoriesReplace operation.
     * @callback module:api/CollectionsApi~privateCollectionCategoriesReplaceCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Replace collection categories
     * Associate new categories with the collection. This will remove all already associated categories and add these new ones
     * @param {Number} collectionId Collection unique identifier
     * @param {module:model/CategoriesCreator} categories Categories list
     * @param {module:api/CollectionsApi~privateCollectionCategoriesReplaceCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionCategoriesReplace = function(collectionId, categories, callback) {
      var postBody = categories;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionCategoriesReplace");
      }

      // verify the required parameter 'categories' is set
      if (categories === undefined || categories === null) {
        throw new Error("Missing the required parameter 'categories' when calling privateCollectionCategoriesReplace");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/categories', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionCategoryDelete operation.
     * @callback module:api/CollectionsApi~privateCollectionCategoryDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete collection category
     * De-associate category from collection
     * @param {Number} collectionId Collection unique identifier
     * @param {Number} categoryId Collection category unique identifier
     * @param {module:api/CollectionsApi~privateCollectionCategoryDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionCategoryDelete = function(collectionId, categoryId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionCategoryDelete");
      }

      // verify the required parameter 'categoryId' is set
      if (categoryId === undefined || categoryId === null) {
        throw new Error("Missing the required parameter 'categoryId' when calling privateCollectionCategoryDelete");
      }


      var pathParams = {
        'collection_id': collectionId,
        'category_id': categoryId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/categories/{category_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionCreate operation.
     * @callback module:api/CollectionsApi~privateCollectionCreateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LocationWarnings} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create collection
     * Create a new Collection by sending collection information
     * @param {module:model/CollectionCreate} collection Collection description
     * @param {module:api/CollectionsApi~privateCollectionCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LocationWarnings}
     */
    this.privateCollectionCreate = function(collection, callback) {
      var postBody = collection;

      // verify the required parameter 'collection' is set
      if (collection === undefined || collection === null) {
        throw new Error("Missing the required parameter 'collection' when calling privateCollectionCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = LocationWarnings;

      return this.apiClient.callApi(
        '/account/collections', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionDelete operation.
     * @callback module:api/CollectionsApi~privateCollectionDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete collection
     * Delete n collection
     * @param {Number} collectionId Collection Unique identifier
     * @param {module:api/CollectionsApi~privateCollectionDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionDelete = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionDelete");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionDetails operation.
     * @callback module:api/CollectionsApi~privateCollectionDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CollectionCompletePrivate} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Collection details
     * View a collection
     * @param {Number} collectionId Collection Unique identifier
     * @param {module:api/CollectionsApi~privateCollectionDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CollectionCompletePrivate}
     */
    this.privateCollectionDetails = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionDetails");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = CollectionCompletePrivate;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionPrivateLinkCreate operation.
     * @callback module:api/CollectionsApi~privateCollectionPrivateLinkCreateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PrivateLinkResponse} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create collection private link
     * Create new private link
     * @param {Number} collectionId Collection unique identifier
     * @param {Object} opts Optional parameters
     * @param {module:model/CollectionPrivateLinkCreator} opts.privateLink 
     * @param {module:api/CollectionsApi~privateCollectionPrivateLinkCreateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PrivateLinkResponse}
     */
    this.privateCollectionPrivateLinkCreate = function(collectionId, opts, callback) {
      opts = opts || {};
      var postBody = opts['privateLink'];

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionPrivateLinkCreate");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PrivateLinkResponse;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/private_links', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionPrivateLinkDelete operation.
     * @callback module:api/CollectionsApi~privateCollectionPrivateLinkDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Disable private link
     * Disable/delete private link for this collection
     * @param {Number} collectionId Collection unique identifier
     * @param {String} linkId Private link token
     * @param {module:api/CollectionsApi~privateCollectionPrivateLinkDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionPrivateLinkDelete = function(collectionId, linkId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionPrivateLinkDelete");
      }

      // verify the required parameter 'linkId' is set
      if (linkId === undefined || linkId === null) {
        throw new Error("Missing the required parameter 'linkId' when calling privateCollectionPrivateLinkDelete");
      }


      var pathParams = {
        'collection_id': collectionId,
        'link_id': linkId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/private_links/{link_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionPrivateLinkUpdate operation.
     * @callback module:api/CollectionsApi~privateCollectionPrivateLinkUpdateCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update collection private link
     * Update existing private link for this collection
     * @param {Number} collectionId Collection unique identifier
     * @param {String} linkId Private link token
     * @param {Object} opts Optional parameters
     * @param {module:model/CollectionPrivateLinkCreator} opts.privateLink 
     * @param {module:api/CollectionsApi~privateCollectionPrivateLinkUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateCollectionPrivateLinkUpdate = function(collectionId, linkId, opts, callback) {
      opts = opts || {};
      var postBody = opts['privateLink'];

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionPrivateLinkUpdate");
      }

      // verify the required parameter 'linkId' is set
      if (linkId === undefined || linkId === null) {
        throw new Error("Missing the required parameter 'linkId' when calling privateCollectionPrivateLinkUpdate");
      }


      var pathParams = {
        'collection_id': collectionId,
        'link_id': linkId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/private_links/{link_id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionPrivateLinksList operation.
     * @callback module:api/CollectionsApi~privateCollectionPrivateLinksListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/PrivateLink>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List collection private links
     * List article private links
     * @param {Number} collectionId Collection unique identifier
     * @param {module:api/CollectionsApi~privateCollectionPrivateLinksListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/PrivateLink>}
     */
    this.privateCollectionPrivateLinksList = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionPrivateLinksList");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [PrivateLink];

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/private_links', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionPublish operation.
     * @callback module:api/CollectionsApi~privateCollectionPublishCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Location} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Collection Publish
     * When a collection is published, a new public version will be generated. Any further updates to the collection will affect the private collection data. In order to make these changes publicly visible, an explicit publish operation is needed.
     * @param {Number} collectionId Collection Unique identifier
     * @param {module:api/CollectionsApi~privateCollectionPublishCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Location}
     */
    this.privateCollectionPublish = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionPublish");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Location;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/publish', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionReserveDoi operation.
     * @callback module:api/CollectionsApi~privateCollectionReserveDoiCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CollectionDOI} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Collection Reserve DOI
     * Reserve DOI for collection
     * @param {Number} collectionId Collection Unique identifier
     * @param {module:api/CollectionsApi~privateCollectionReserveDoiCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CollectionDOI}
     */
    this.privateCollectionReserveDoi = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionReserveDoi");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = CollectionDOI;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/reserve_doi', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionReserveHandle operation.
     * @callback module:api/CollectionsApi~privateCollectionReserveHandleCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CollectionHandle} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Collection Reserve Handle
     * Reserve Handle for collection
     * @param {Number} collectionId Collection Unique identifier
     * @param {module:api/CollectionsApi~privateCollectionReserveHandleCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CollectionHandle}
     */
    this.privateCollectionReserveHandle = function(collectionId, callback) {
      var postBody = null;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionReserveHandle");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = CollectionHandle;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/reserve_handle', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionResource operation.
     * @callback module:api/CollectionsApi~privateCollectionResourceCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Location} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Collection Resource
     * Edit collection resource data.
     * @param {Number} collectionId Collection unique identifier
     * @param {module:model/Resource} resource Resource data
     * @param {module:api/CollectionsApi~privateCollectionResourceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Location}
     */
    this.privateCollectionResource = function(collectionId, resource, callback) {
      var postBody = resource;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionResource");
      }

      // verify the required parameter 'resource' is set
      if (resource === undefined || resource === null) {
        throw new Error("Missing the required parameter 'resource' when calling privateCollectionResource");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Location;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}/resource', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionUpdate operation.
     * @callback module:api/CollectionsApi~privateCollectionUpdateCallback
     * @param {String} error Error message, if any.
     * @param {module:model/LocationWarningsUpdate} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update collection
     * Update collection details; request can also be made with the PATCH method.
     * @param {Number} collectionId Collection Unique identifier
     * @param {module:model/CollectionUpdate} collection Collection description
     * @param {module:api/CollectionsApi~privateCollectionUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/LocationWarningsUpdate}
     */
    this.privateCollectionUpdate = function(collectionId, collection, callback) {
      var postBody = collection;

      // verify the required parameter 'collectionId' is set
      if (collectionId === undefined || collectionId === null) {
        throw new Error("Missing the required parameter 'collectionId' when calling privateCollectionUpdate");
      }

      // verify the required parameter 'collection' is set
      if (collection === undefined || collection === null) {
        throw new Error("Missing the required parameter 'collection' when calling privateCollectionUpdate");
      }


      var pathParams = {
        'collection_id': collectionId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = LocationWarningsUpdate;

      return this.apiClient.callApi(
        '/account/collections/{collection_id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionsList operation.
     * @callback module:api/CollectionsApi~privateCollectionsListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Collection>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Collections List
     * List private collections
     * @param {Object} opts Optional parameters
     * @param {Number} opts.page Page number. Used for pagination with page_size
     * @param {Number} opts.pageSize The number of results included on a page. Used for pagination with page (default to 10)
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:model/String} opts.order The field by which to order. Default varies by endpoint/resource. (default to published_date)
     * @param {module:model/String} opts.orderDirection  (default to desc)
     * @param {module:api/CollectionsApi~privateCollectionsListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Collection>}
     */
    this.privateCollectionsList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'page': opts['page'],
        'page_size': opts['pageSize'],
        'limit': opts['limit'],
        'offset': opts['offset'],
        'order': opts['order'],
        'order_direction': opts['orderDirection'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Collection];

      return this.apiClient.callApi(
        '/account/collections', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCollectionsSearch operation.
     * @callback module:api/CollectionsApi~privateCollectionsSearchCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Collection>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Collections Search
     * Returns a list of private Collections
     * @param {module:model/PrivateCollectionSearch} search Search Parameters
     * @param {module:api/CollectionsApi~privateCollectionsSearchCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Collection>}
     */
    this.privateCollectionsSearch = function(search, callback) {
      var postBody = search;

      // verify the required parameter 'search' is set
      if (search === undefined || search === null) {
        throw new Error("Missing the required parameter 'search' when calling privateCollectionsSearch");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Collection];

      return this.apiClient.callApi(
        '/account/collections/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
