/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AccountCreate', 'model/AccountGroupRoles', 'model/AccountGroupRolesCreate', 'model/AccountUpdate', 'model/Article', 'model/Category', 'model/Curation', 'model/CurationComment', 'model/CurationCommentCreate', 'model/CurationDetail', 'model/ErrorMessage', 'model/Group', 'model/GroupEmbargoOptions', 'model/Institution', 'model/InstitutionAccountsSearch', 'model/ResponseMessage', 'model/Role', 'model/ShortAccount', 'model/ShortCustomField', 'model/User'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AccountCreate'), require('../model/AccountGroupRoles'), require('../model/AccountGroupRolesCreate'), require('../model/AccountUpdate'), require('../model/Article'), require('../model/Category'), require('../model/Curation'), require('../model/CurationComment'), require('../model/CurationCommentCreate'), require('../model/CurationDetail'), require('../model/ErrorMessage'), require('../model/Group'), require('../model/GroupEmbargoOptions'), require('../model/Institution'), require('../model/InstitutionAccountsSearch'), require('../model/ResponseMessage'), require('../model/Role'), require('../model/ShortAccount'), require('../model/ShortCustomField'), require('../model/User'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.InstitutionsApi = factory(root.FigshareApi.ApiClient, root.FigshareApi.AccountCreate, root.FigshareApi.AccountGroupRoles, root.FigshareApi.AccountGroupRolesCreate, root.FigshareApi.AccountUpdate, root.FigshareApi.Article, root.FigshareApi.Category, root.FigshareApi.Curation, root.FigshareApi.CurationComment, root.FigshareApi.CurationCommentCreate, root.FigshareApi.CurationDetail, root.FigshareApi.ErrorMessage, root.FigshareApi.Group, root.FigshareApi.GroupEmbargoOptions, root.FigshareApi.Institution, root.FigshareApi.InstitutionAccountsSearch, root.FigshareApi.ResponseMessage, root.FigshareApi.Role, root.FigshareApi.ShortAccount, root.FigshareApi.ShortCustomField, root.FigshareApi.User);
  }
}(this, function(ApiClient, AccountCreate, AccountGroupRoles, AccountGroupRolesCreate, AccountUpdate, Article, Category, Curation, CurationComment, CurationCommentCreate, CurationDetail, ErrorMessage, Group, GroupEmbargoOptions, Institution, InstitutionAccountsSearch, ResponseMessage, Role, ShortAccount, ShortCustomField, User) {
  'use strict';

  /**
   * Institutions service.
   * @module api/InstitutionsApi
   * @version 2.0.0
   */

  /**
   * Constructs a new InstitutionsApi. 
   * @alias module:api/InstitutionsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the accountInstitutionCuration operation.
     * @callback module:api/InstitutionsApi~accountInstitutionCurationCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CurationDetail} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Institution Curation Review
     * Retrieve a certain curation review by its ID
     * @param {Number} curationId ID of the curation
     * @param {module:api/InstitutionsApi~accountInstitutionCurationCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CurationDetail}
     */
    this.accountInstitutionCuration = function(curationId, callback) {
      var postBody = null;

      // verify the required parameter 'curationId' is set
      if (curationId === undefined || curationId === null) {
        throw new Error("Missing the required parameter 'curationId' when calling accountInstitutionCuration");
      }


      var pathParams = {
        'curation_id': curationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = CurationDetail;

      return this.apiClient.callApi(
        '/account/institution/review/{curation_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountInstitutionCurationComments operation.
     * @callback module:api/InstitutionsApi~accountInstitutionCurationCommentsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/CurationComment} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Institution Curation Review Comments
     * Retrieve a certain curation review's comments.
     * @param {Number} curationId ID of the curation
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:api/InstitutionsApi~accountInstitutionCurationCommentsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/CurationComment}
     */
    this.accountInstitutionCurationComments = function(curationId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'curationId' is set
      if (curationId === undefined || curationId === null) {
        throw new Error("Missing the required parameter 'curationId' when calling accountInstitutionCurationComments");
      }


      var pathParams = {
        'curation_id': curationId
      };
      var queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = CurationComment;

      return this.apiClient.callApi(
        '/account/institution/review/{curation_id}/comments', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountInstitutionCurationComments_0 operation.
     * @callback module:api/InstitutionsApi~accountInstitutionCurationComments_0Callback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * POST Institution Curation Review Comment
     * Add a new comment to the review.
     * @param {Number} curationId ID of the curation
     * @param {module:model/CurationCommentCreate} curationComment The content/value of the comment.
     * @param {module:api/InstitutionsApi~accountInstitutionCurationComments_0Callback} callback The callback function, accepting three arguments: error, data, response
     */
    this.accountInstitutionCurationComments_0 = function(curationId, curationComment, callback) {
      var postBody = curationComment;

      // verify the required parameter 'curationId' is set
      if (curationId === undefined || curationId === null) {
        throw new Error("Missing the required parameter 'curationId' when calling accountInstitutionCurationComments_0");
      }

      // verify the required parameter 'curationComment' is set
      if (curationComment === undefined || curationComment === null) {
        throw new Error("Missing the required parameter 'curationComment' when calling accountInstitutionCurationComments_0");
      }


      var pathParams = {
        'curation_id': curationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/institution/review/{curation_id}/comments', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the accountInstitutionCurations operation.
     * @callback module:api/InstitutionsApi~accountInstitutionCurationsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Curation} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Institution Curation Reviews
     * Retrieve a list of curation reviews for this institution
     * @param {Object} opts Optional parameters
     * @param {Number} opts.groupId Filter by the group ID
     * @param {Number} opts.articleId Retrieve the reviews for this article
     * @param {module:model/String} opts.status Filter by the status of the review
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:api/InstitutionsApi~accountInstitutionCurationsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Curation}
     */
    this.accountInstitutionCurations = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'group_id': opts['groupId'],
        'article_id': opts['articleId'],
        'status': opts['status'],
        'limit': opts['limit'],
        'offset': opts['offset'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Curation;

      return this.apiClient.callApi(
        '/account/institution/reviews', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the customFieldsList operation.
     * @callback module:api/InstitutionsApi~customFieldsListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ShortCustomField>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private account institution group custom fields
     * Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
     * @param {Object} opts Optional parameters
     * @param {Number} opts.groupId Group_id
     * @param {module:api/InstitutionsApi~customFieldsListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ShortCustomField>}
     */
    this.customFieldsList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'group_id': opts['groupId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ShortCustomField];

      return this.apiClient.callApi(
        '/account/institution/custom_fields', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the customFieldsUpload operation.
     * @callback module:api/InstitutionsApi~customFieldsUploadCallback
     * @param {String} error Error message, if any.
     * @param {Object} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Custom fields values files upload
     * Uploads a CSV containing values for a specific custom field of type <b>dropdown_large_list</b>. More details in the <a href=\"#custom_fields\">Custom Fields section</a>
     * @param {Number} customFieldId Custom field identifier
     * @param {Object} opts Optional parameters
     * @param {File} opts.externalFile CSV file to be uploaded
     * @param {module:api/InstitutionsApi~customFieldsUploadCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Object}
     */
    this.customFieldsUpload = function(customFieldId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'customFieldId' is set
      if (customFieldId === undefined || customFieldId === null) {
        throw new Error("Missing the required parameter 'customFieldId' when calling customFieldsUpload");
      }


      var pathParams = {
        'custom_field_id': customFieldId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'external_file': opts['externalFile']
      };

      var authNames = ['OAuth2'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json'];
      var returnType = Object;

      return this.apiClient.callApi(
        '/account/institution/custom_fields/{custom_field_id}/items/upload', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the institutionArticles operation.
     * @callback module:api/InstitutionsApi~institutionArticlesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Article>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Institution Articles
     * Returns a list of articles belonging to the institution
     * @param {String} institutionStringId 
     * @param {String} resourceId 
     * @param {String} filename 
     * @param {module:api/InstitutionsApi~institutionArticlesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Article>}
     */
    this.institutionArticles = function(institutionStringId, resourceId, filename, callback) {
      var postBody = null;

      // verify the required parameter 'institutionStringId' is set
      if (institutionStringId === undefined || institutionStringId === null) {
        throw new Error("Missing the required parameter 'institutionStringId' when calling institutionArticles");
      }

      // verify the required parameter 'resourceId' is set
      if (resourceId === undefined || resourceId === null) {
        throw new Error("Missing the required parameter 'resourceId' when calling institutionArticles");
      }

      // verify the required parameter 'filename' is set
      if (filename === undefined || filename === null) {
        throw new Error("Missing the required parameter 'filename' when calling institutionArticles");
      }


      var pathParams = {
        'institution_string_id': institutionStringId
      };
      var queryParams = {
        'resource_id': resourceId,
        'filename': filename,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Article];

      return this.apiClient.callApi(
        '/institutions/{institution_string_id}/articles/filter-by', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the institutionHrfeedUpload operation.
     * @callback module:api/InstitutionsApi~institutionHrfeedUploadCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ResponseMessage} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Institution HRfeed Upload
     * More info in the <a href=\"#hr_feed\">HR Feed section</a>
     * @param {Object} opts Optional parameters
     * @param {File} opts.hrfeed You can find an example in the Hr Feed section
     * @param {module:api/InstitutionsApi~institutionHrfeedUploadCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ResponseMessage}
     */
    this.institutionHrfeedUpload = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'hrfeed': opts['hrfeed']
      };

      var authNames = ['OAuth2'];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json'];
      var returnType = ResponseMessage;

      return this.apiClient.callApi(
        '/institution/hrfeed/upload', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateAccountInstitutionUser operation.
     * @callback module:api/InstitutionsApi~privateAccountInstitutionUserCallback
     * @param {String} error Error message, if any.
     * @param {module:model/User} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Institution User
     * Retrieve institution user information using the account_id
     * @param {Number} accountId Account identifier the user is associated to
     * @param {module:api/InstitutionsApi~privateAccountInstitutionUserCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/User}
     */
    this.privateAccountInstitutionUser = function(accountId, callback) {
      var postBody = null;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling privateAccountInstitutionUser");
      }


      var pathParams = {
        'account_id': accountId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = User;

      return this.apiClient.callApi(
        '/account/institution/users/{account_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateCategoriesList operation.
     * @callback module:api/InstitutionsApi~privateCategoriesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Category>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Categories
     * List institution categories (including parent Categories)
     * @param {module:api/InstitutionsApi~privateCategoriesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Category>}
     */
    this.privateCategoriesList = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Category];

      return this.apiClient.callApi(
        '/account/categories', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateGroupEmbargoOptionsDetails operation.
     * @callback module:api/InstitutionsApi~privateGroupEmbargoOptionsDetailsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/GroupEmbargoOptions>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Institution Group Embargo Options
     * Account institution group embargo options details
     * @param {Number} groupId Group identifier
     * @param {module:api/InstitutionsApi~privateGroupEmbargoOptionsDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/GroupEmbargoOptions>}
     */
    this.privateGroupEmbargoOptionsDetails = function(groupId, callback) {
      var postBody = null;

      // verify the required parameter 'groupId' is set
      if (groupId === undefined || groupId === null) {
        throw new Error("Missing the required parameter 'groupId' when calling privateGroupEmbargoOptionsDetails");
      }


      var pathParams = {
        'group_id': groupId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [GroupEmbargoOptions];

      return this.apiClient.callApi(
        '/account/institution/groups/{group_id}/embargo_options', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionAccountGroupRoleDelete operation.
     * @callback module:api/InstitutionsApi~privateInstitutionAccountGroupRoleDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete Institution Account Group Role
     * Delete Institution Account Group Role
     * @param {Number} accountId Account identifier for which to remove the role
     * @param {Number} groupId Group identifier for which to remove the role
     * @param {Number} roleId Role identifier
     * @param {module:api/InstitutionsApi~privateInstitutionAccountGroupRoleDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateInstitutionAccountGroupRoleDelete = function(accountId, groupId, roleId, callback) {
      var postBody = null;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling privateInstitutionAccountGroupRoleDelete");
      }

      // verify the required parameter 'groupId' is set
      if (groupId === undefined || groupId === null) {
        throw new Error("Missing the required parameter 'groupId' when calling privateInstitutionAccountGroupRoleDelete");
      }

      // verify the required parameter 'roleId' is set
      if (roleId === undefined || roleId === null) {
        throw new Error("Missing the required parameter 'roleId' when calling privateInstitutionAccountGroupRoleDelete");
      }


      var pathParams = {
        'account_id': accountId,
        'group_id': groupId,
        'role_id': roleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/institution/roles/{account_id}/{group_id}/{role_id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionAccountGroupRoles operation.
     * @callback module:api/InstitutionsApi~privateInstitutionAccountGroupRolesCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AccountGroupRoles} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List Institution Account Group Roles
     * List Institution Account Group Roles
     * @param {Number} accountId Account identifier the user is associated to
     * @param {module:api/InstitutionsApi~privateInstitutionAccountGroupRolesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AccountGroupRoles}
     */
    this.privateInstitutionAccountGroupRoles = function(accountId, callback) {
      var postBody = null;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling privateInstitutionAccountGroupRoles");
      }


      var pathParams = {
        'account_id': accountId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = AccountGroupRoles;

      return this.apiClient.callApi(
        '/account/institution/roles/{account_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionAccountGroupRolesCreate operation.
     * @callback module:api/InstitutionsApi~privateInstitutionAccountGroupRolesCreateCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add Institution Account Group Roles
     * Add Institution Account Group Roles
     * @param {Number} accountId Account identifier the user is associated to
     * @param {module:model/AccountGroupRolesCreate} account Account description
     * @param {module:api/InstitutionsApi~privateInstitutionAccountGroupRolesCreateCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateInstitutionAccountGroupRolesCreate = function(accountId, account, callback) {
      var postBody = account;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling privateInstitutionAccountGroupRolesCreate");
      }

      // verify the required parameter 'account' is set
      if (account === undefined || account === null) {
        throw new Error("Missing the required parameter 'account' when calling privateInstitutionAccountGroupRolesCreate");
      }


      var pathParams = {
        'account_id': accountId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/institution/roles/{account_id}', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionAccountsCreate operation.
     * @callback module:api/InstitutionsApi~privateInstitutionAccountsCreateCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new Institution Account
     * Create a new Account by sending account information
     * @param {module:model/AccountCreate} account Account description
     * @param {module:api/InstitutionsApi~privateInstitutionAccountsCreateCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateInstitutionAccountsCreate = function(account, callback) {
      var postBody = account;

      // verify the required parameter 'account' is set
      if (account === undefined || account === null) {
        throw new Error("Missing the required parameter 'account' when calling privateInstitutionAccountsCreate");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/institution/accounts', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionAccountsList operation.
     * @callback module:api/InstitutionsApi~privateInstitutionAccountsListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ShortAccount>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Institution Accounts
     * Returns the accounts for which the account has administrative privileges (assigned and inherited).
     * @param {Object} opts Optional parameters
     * @param {Number} opts.page Page number. Used for pagination with page_size
     * @param {Number} opts.pageSize The number of results included on a page. Used for pagination with page (default to 10)
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {Number} opts.isActive Filter by active status
     * @param {String} opts.institutionUserId Filter by institution_user_id
     * @param {String} opts.email Filter by email
     * @param {Number} opts.idLte Retrieve accounts with an ID lower or equal to the specified value
     * @param {Number} opts.idGte Retrieve accounts with an ID greater or equal to the specified value
     * @param {module:api/InstitutionsApi~privateInstitutionAccountsListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ShortAccount>}
     */
    this.privateInstitutionAccountsList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'page': opts['page'],
        'page_size': opts['pageSize'],
        'limit': opts['limit'],
        'offset': opts['offset'],
        'is_active': opts['isActive'],
        'institution_user_id': opts['institutionUserId'],
        'email': opts['email'],
        'id_lte': opts['idLte'],
        'id_gte': opts['idGte'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ShortAccount];

      return this.apiClient.callApi(
        '/account/institution/accounts', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionAccountsSearch operation.
     * @callback module:api/InstitutionsApi~privateInstitutionAccountsSearchCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ShortAccount>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Institution Accounts Search
     * Returns the accounts for which the account has administrative privileges (assigned and inherited).
     * @param {module:model/InstitutionAccountsSearch} search Search Parameters
     * @param {module:api/InstitutionsApi~privateInstitutionAccountsSearchCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ShortAccount>}
     */
    this.privateInstitutionAccountsSearch = function(search, callback) {
      var postBody = search;

      // verify the required parameter 'search' is set
      if (search === undefined || search === null) {
        throw new Error("Missing the required parameter 'search' when calling privateInstitutionAccountsSearch");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ShortAccount];

      return this.apiClient.callApi(
        '/account/institution/accounts/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionAccountsUpdate operation.
     * @callback module:api/InstitutionsApi~privateInstitutionAccountsUpdateCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update Institution Account
     * Update Institution Account
     * @param {Number} accountId Account identifier the user is associated to
     * @param {module:model/AccountUpdate} account Account description
     * @param {module:api/InstitutionsApi~privateInstitutionAccountsUpdateCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.privateInstitutionAccountsUpdate = function(accountId, account, callback) {
      var postBody = account;

      // verify the required parameter 'accountId' is set
      if (accountId === undefined || accountId === null) {
        throw new Error("Missing the required parameter 'accountId' when calling privateInstitutionAccountsUpdate");
      }

      // verify the required parameter 'account' is set
      if (account === undefined || account === null) {
        throw new Error("Missing the required parameter 'account' when calling privateInstitutionAccountsUpdate");
      }


      var pathParams = {
        'account_id': accountId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/account/institution/accounts/{account_id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionArticles operation.
     * @callback module:api/InstitutionsApi~privateInstitutionArticlesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Article>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Institution Articles
     * Get Articles from own institution. User must be administrator of the institution
     * @param {Object} opts Optional parameters
     * @param {Number} opts.page Page number. Used for pagination with page_size
     * @param {Number} opts.pageSize The number of results included on a page. Used for pagination with page (default to 10)
     * @param {Number} opts.limit Number of results included on a page. Used for pagination with query
     * @param {Number} opts.offset Where to start the listing(the offset of the first result). Used for pagination with limit
     * @param {module:model/String} opts.order The field by which to order. Default varies by endpoint/resource. (default to published_date)
     * @param {module:model/String} opts.orderDirection  (default to desc)
     * @param {String} opts.publishedSince Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
     * @param {String} opts.modifiedSince Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
     * @param {Number} opts.status only return collections with this status
     * @param {String} opts.resourceDoi only return collections with this resource_doi
     * @param {Number} opts.itemType Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model
     * @param {module:api/InstitutionsApi~privateInstitutionArticlesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Article>}
     */
    this.privateInstitutionArticles = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'page': opts['page'],
        'page_size': opts['pageSize'],
        'limit': opts['limit'],
        'offset': opts['offset'],
        'order': opts['order'],
        'order_direction': opts['orderDirection'],
        'published_since': opts['publishedSince'],
        'modified_since': opts['modifiedSince'],
        'status': opts['status'],
        'resource_doi': opts['resourceDoi'],
        'item_type': opts['itemType'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Article];

      return this.apiClient.callApi(
        '/account/institution/articles', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionDetails operation.
     * @callback module:api/InstitutionsApi~privateInstitutionDetailsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Institution} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Institutions
     * Account institution details
     * @param {module:api/InstitutionsApi~privateInstitutionDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Institution}
     */
    this.privateInstitutionDetails = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Institution;

      return this.apiClient.callApi(
        '/account/institution', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionEmbargoOptionsDetails operation.
     * @callback module:api/InstitutionsApi~privateInstitutionEmbargoOptionsDetailsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/GroupEmbargoOptions>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Institution embargo options
     * Account institution embargo options details
     * @param {module:api/InstitutionsApi~privateInstitutionEmbargoOptionsDetailsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/GroupEmbargoOptions>}
     */
    this.privateInstitutionEmbargoOptionsDetails = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [GroupEmbargoOptions];

      return this.apiClient.callApi(
        '/account/institution/embargo_options', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionGroupsList operation.
     * @callback module:api/InstitutionsApi~privateInstitutionGroupsListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Group>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Institution Groups
     * Returns the groups for which the account has administrative privileges (assigned and inherited).
     * @param {module:api/InstitutionsApi~privateInstitutionGroupsListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Group>}
     */
    this.privateInstitutionGroupsList = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Group];

      return this.apiClient.callApi(
        '/account/institution/groups', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateInstitutionRolesList operation.
     * @callback module:api/InstitutionsApi~privateInstitutionRolesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Role>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Institution Roles
     * Returns the roles available for groups and the institution group.
     * @param {module:api/InstitutionsApi~privateInstitutionRolesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Role>}
     */
    this.privateInstitutionRolesList = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Role];

      return this.apiClient.callApi(
        '/account/institution/roles', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
