/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Account', 'model/Category', 'model/ErrorMessage', 'model/FundingInformation', 'model/FundingSearch', 'model/ItemType', 'model/License'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Account'), require('../model/Category'), require('../model/ErrorMessage'), require('../model/FundingInformation'), require('../model/FundingSearch'), require('../model/ItemType'), require('../model/License'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.OtherApi = factory(root.FigshareApi.ApiClient, root.FigshareApi.Account, root.FigshareApi.Category, root.FigshareApi.ErrorMessage, root.FigshareApi.FundingInformation, root.FigshareApi.FundingSearch, root.FigshareApi.ItemType, root.FigshareApi.License);
  }
}(this, function(ApiClient, Account, Category, ErrorMessage, FundingInformation, FundingSearch, ItemType, License) {
  'use strict';

  /**
   * Other service.
   * @module api/OtherApi
   * @version 2.0.0
   */

  /**
   * Constructs a new OtherApi. 
   * @alias module:api/OtherApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the categoriesList operation.
     * @callback module:api/OtherApi~categoriesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Category>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Categories
     * Returns a list of public categories
     * @param {module:api/OtherApi~categoriesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Category>}
     */
    this.categoriesList = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Category];

      return this.apiClient.callApi(
        '/categories', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the fileDownload operation.
     * @callback module:api/OtherApi~fileDownloadCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public File Download
     * Starts the download of a file
     * @param {Number} fileId 
     * @param {module:api/OtherApi~fileDownloadCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.fileDownload = function(fileId, callback) {
      var postBody = null;

      // verify the required parameter 'fileId' is set
      if (fileId === undefined || fileId === null) {
        throw new Error("Missing the required parameter 'fileId' when calling fileDownload");
      }


      var pathParams = {
        'file_id': fileId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/force-download'];
      var returnType = null;

      return this.apiClient.callApi(
        '/file/download/{file_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the itemTypesList operation.
     * @callback module:api/OtherApi~itemTypesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ItemType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Item Types
     * Returns the list of Item Types of the requested group. If no user is authenticated, returns the item types available for Figshare.
     * @param {Object} opts Optional parameters
     * @param {Number} opts.groupId Identifier of the group for which the item types are requested (default to 0)
     * @param {module:api/OtherApi~itemTypesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ItemType>}
     */
    this.itemTypesList = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'group_id': opts['groupId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ItemType];

      return this.apiClient.callApi(
        '/item_types', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the licensesList operation.
     * @callback module:api/OtherApi~licensesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/License>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Public Licenses
     * Returns a list of public licenses
     * @param {module:api/OtherApi~licensesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/License>}
     */
    this.licensesList = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [License];

      return this.apiClient.callApi(
        '/licenses', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateAccount operation.
     * @callback module:api/OtherApi~privateAccountCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Account} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account information
     * Account information for token/personal token
     * @param {module:api/OtherApi~privateAccountCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Account}
     */
    this.privateAccount = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Account;

      return this.apiClient.callApi(
        '/account', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateFundingSearch operation.
     * @callback module:api/OtherApi~privateFundingSearchCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/FundingInformation>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search Funding
     * Search for fundings
     * @param {Object} opts Optional parameters
     * @param {module:model/FundingSearch} opts.search Search Parameters
     * @param {module:api/OtherApi~privateFundingSearchCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/FundingInformation>}
     */
    this.privateFundingSearch = function(opts, callback) {
      opts = opts || {};
      var postBody = opts['search'];


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [FundingInformation];

      return this.apiClient.callApi(
        '/account/funding/search', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the privateLicensesList operation.
     * @callback module:api/OtherApi~privateLicensesListCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/License>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Private Account Licenses
     * This is a private endpoint that requires OAuth. It will return a list with figshare public licenses AND licenses defined for account's institution.
     * @param {module:api/OtherApi~privateLicensesListCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/License>}
     */
    this.privateLicensesList = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['OAuth2'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [License];

      return this.apiClient.callApi(
        '/account/licenses', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
