/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.Account = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The Account model module.
   * @module model/Account
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>Account</code>.
   * @alias module:model/Account
   * @class
   * @param id {Number} Account id
   * @param firstName {String} First Name
   * @param lastName {String} Last Name
   * @param usedQuotaPrivate {Number} Account used private quota
   * @param modifiedDate {String} Date of last account modification
   * @param usedQuota {Number} Account total used quota
   * @param createdDate {String} Date when account was created
   * @param quota {Number} Account quota
   * @param groupId {Number} Account group id
   * @param institutionUserId {String} Account institution user id
   * @param institutionId {Number} Account institution
   * @param email {String} User email
   * @param usedQuotaPublic {Number} Account public used quota
   * @param pendingQuotaRequest {Boolean} True if a quota request is pending
   * @param active {Number} Account activity status
   * @param maximumFileSize {Number} Maximum upload size for account
   */
  var exports = function(id, firstName, lastName, usedQuotaPrivate, modifiedDate, usedQuota, createdDate, quota, groupId, institutionUserId, institutionId, email, usedQuotaPublic, pendingQuotaRequest, active, maximumFileSize) {
    this.id = id;
    this.firstName = firstName;
    this.lastName = lastName;
    this.usedQuotaPrivate = usedQuotaPrivate;
    this.modifiedDate = modifiedDate;
    this.usedQuota = usedQuota;
    this.createdDate = createdDate;
    this.quota = quota;
    this.groupId = groupId;
    this.institutionUserId = institutionUserId;
    this.institutionId = institutionId;
    this.email = email;
    this.usedQuotaPublic = usedQuotaPublic;
    this.pendingQuotaRequest = pendingQuotaRequest;
    this.active = active;
    this.maximumFileSize = maximumFileSize;
  };

  /**
   * Constructs a <code>Account</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Account} obj Optional instance to populate.
   * @return {module:model/Account} The populated <code>Account</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('first_name'))
        obj.firstName = ApiClient.convertToType(data['first_name'], 'String');
      if (data.hasOwnProperty('last_name'))
        obj.lastName = ApiClient.convertToType(data['last_name'], 'String');
      if (data.hasOwnProperty('used_quota_private'))
        obj.usedQuotaPrivate = ApiClient.convertToType(data['used_quota_private'], 'Number');
      if (data.hasOwnProperty('modified_date'))
        obj.modifiedDate = ApiClient.convertToType(data['modified_date'], 'String');
      if (data.hasOwnProperty('used_quota'))
        obj.usedQuota = ApiClient.convertToType(data['used_quota'], 'Number');
      if (data.hasOwnProperty('created_date'))
        obj.createdDate = ApiClient.convertToType(data['created_date'], 'String');
      if (data.hasOwnProperty('quota'))
        obj.quota = ApiClient.convertToType(data['quota'], 'Number');
      if (data.hasOwnProperty('group_id'))
        obj.groupId = ApiClient.convertToType(data['group_id'], 'Number');
      if (data.hasOwnProperty('institution_user_id'))
        obj.institutionUserId = ApiClient.convertToType(data['institution_user_id'], 'String');
      if (data.hasOwnProperty('institution_id'))
        obj.institutionId = ApiClient.convertToType(data['institution_id'], 'Number');
      if (data.hasOwnProperty('email'))
        obj.email = ApiClient.convertToType(data['email'], 'String');
      if (data.hasOwnProperty('used_quota_public'))
        obj.usedQuotaPublic = ApiClient.convertToType(data['used_quota_public'], 'Number');
      if (data.hasOwnProperty('pending_quota_request'))
        obj.pendingQuotaRequest = ApiClient.convertToType(data['pending_quota_request'], 'Boolean');
      if (data.hasOwnProperty('active'))
        obj.active = ApiClient.convertToType(data['active'], 'Number');
      if (data.hasOwnProperty('maximum_file_size'))
        obj.maximumFileSize = ApiClient.convertToType(data['maximum_file_size'], 'Number');
    }
    return obj;
  }

  /**
   * Account id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * First Name
   * @member {String} firstName
   */
  exports.prototype.firstName = undefined;

  /**
   * Last Name
   * @member {String} lastName
   */
  exports.prototype.lastName = undefined;

  /**
   * Account used private quota
   * @member {Number} usedQuotaPrivate
   */
  exports.prototype.usedQuotaPrivate = undefined;

  /**
   * Date of last account modification
   * @member {String} modifiedDate
   */
  exports.prototype.modifiedDate = undefined;

  /**
   * Account total used quota
   * @member {Number} usedQuota
   */
  exports.prototype.usedQuota = undefined;

  /**
   * Date when account was created
   * @member {String} createdDate
   */
  exports.prototype.createdDate = undefined;

  /**
   * Account quota
   * @member {Number} quota
   */
  exports.prototype.quota = undefined;

  /**
   * Account group id
   * @member {Number} groupId
   */
  exports.prototype.groupId = undefined;

  /**
   * Account institution user id
   * @member {String} institutionUserId
   */
  exports.prototype.institutionUserId = undefined;

  /**
   * Account institution
   * @member {Number} institutionId
   */
  exports.prototype.institutionId = undefined;

  /**
   * User email
   * @member {String} email
   */
  exports.prototype.email = undefined;

  /**
   * Account public used quota
   * @member {Number} usedQuotaPublic
   */
  exports.prototype.usedQuotaPublic = undefined;

  /**
   * True if a quota request is pending
   * @member {Boolean} pendingQuotaRequest
   */
  exports.prototype.pendingQuotaRequest = undefined;

  /**
   * Account activity status
   * @member {Number} active
   */
  exports.prototype.active = undefined;

  /**
   * Maximum upload size for account
   * @member {Number} maximumFileSize
   */
  exports.prototype.maximumFileSize = undefined;


  return exports;

}));
