/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.AccountReport = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The AccountReport model module.
   * @module model/AccountReport
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>AccountReport</code>.
   * @alias module:model/AccountReport
   * @class
   * @param id {Number} A unique ID for the AccountRecord
   * @param accountId {Number} The ID of the account which generated this report.
   * @param createdDate {String} Date when the AccountReport was requested
   * @param status {module:model/AccountReport.StatusEnum} Status of the report
   * @param downloadUrl {String} The download link for the generated XLSX
   * @param groupId {Number} The group ID that was used to filter the report, if any.
   */
  var exports = function(id, accountId, createdDate, status, downloadUrl, groupId) {
    this.id = id;
    this.accountId = accountId;
    this.createdDate = createdDate;
    this.status = status;
    this.downloadUrl = downloadUrl;
    this.groupId = groupId;
  };

  /**
   * Constructs a <code>AccountReport</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AccountReport} obj Optional instance to populate.
   * @return {module:model/AccountReport} The populated <code>AccountReport</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('account_id'))
        obj.accountId = ApiClient.convertToType(data['account_id'], 'Number');
      if (data.hasOwnProperty('created_date'))
        obj.createdDate = ApiClient.convertToType(data['created_date'], 'String');
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('download_url'))
        obj.downloadUrl = ApiClient.convertToType(data['download_url'], 'String');
      if (data.hasOwnProperty('group_id'))
        obj.groupId = ApiClient.convertToType(data['group_id'], 'Number');
    }
    return obj;
  }

  /**
   * A unique ID for the AccountRecord
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The ID of the account which generated this report.
   * @member {Number} accountId
   */
  exports.prototype.accountId = undefined;

  /**
   * Date when the AccountReport was requested
   * @member {String} createdDate
   */
  exports.prototype.createdDate = undefined;

  /**
   * Status of the report
   * @member {module:model/AccountReport.StatusEnum} status
   */
  exports.prototype.status = undefined;

  /**
   * The download link for the generated XLSX
   * @member {String} downloadUrl
   */
  exports.prototype.downloadUrl = undefined;

  /**
   * The group ID that was used to filter the report, if any.
   * @member {Number} groupId
   */
  exports.prototype.groupId = undefined;



  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "missing"
     * @const
     */
    missing: "missing",

    /**
     * value: "pending"
     * @const
     */
    pending: "pending",

    /**
     * value: "done"
     * @const
     */
    done: "done"
  };

  return exports;

}));
