/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Timeline'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Timeline'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.Article = factory(root.FigshareApi.ApiClient, root.FigshareApi.Timeline);
  }
}(this, function(ApiClient, Timeline) {
  'use strict';

  /**
   * The Article model module.
   * @module model/Article
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>Article</code>.
   * @alias module:model/Article
   * @class
   * @param id {Number} Unique identifier for article
   * @param title {String} Title of article
   * @param doi {String} DOI
   * @param handle {String} Handle
   * @param url {String} Api endpoint for article
   * @param urlPublicHtml {String} Public site endpoint for article
   * @param urlPublicApi {String} Public Api endpoint for article
   * @param urlPrivateHtml {String} Private site endpoint for article
   * @param urlPrivateApi {String} Private Api endpoint for article
   * @param timeline {module:model/Timeline} Various timeline dates
   * @param thumb {String} Thumbnail image
   * @param definedType {Number} Type of article identifier
   * @param definedTypeName {String} Name of the article type identifier
   */
  var exports = function(id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName) {
    this.id = id;
    this.title = title;
    this.doi = doi;
    this.handle = handle;
    this.url = url;
    this.urlPublicHtml = urlPublicHtml;
    this.urlPublicApi = urlPublicApi;
    this.urlPrivateHtml = urlPrivateHtml;
    this.urlPrivateApi = urlPrivateApi;
    this.timeline = timeline;
    this.thumb = thumb;
    this.definedType = definedType;
    this.definedTypeName = definedTypeName;
  };

  /**
   * Constructs a <code>Article</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Article} obj Optional instance to populate.
   * @return {module:model/Article} The populated <code>Article</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('title'))
        obj.title = ApiClient.convertToType(data['title'], 'String');
      if (data.hasOwnProperty('doi'))
        obj.doi = ApiClient.convertToType(data['doi'], 'String');
      if (data.hasOwnProperty('handle'))
        obj.handle = ApiClient.convertToType(data['handle'], 'String');
      if (data.hasOwnProperty('url'))
        obj.url = ApiClient.convertToType(data['url'], 'String');
      if (data.hasOwnProperty('url_public_html'))
        obj.urlPublicHtml = ApiClient.convertToType(data['url_public_html'], 'String');
      if (data.hasOwnProperty('url_public_api'))
        obj.urlPublicApi = ApiClient.convertToType(data['url_public_api'], 'String');
      if (data.hasOwnProperty('url_private_html'))
        obj.urlPrivateHtml = ApiClient.convertToType(data['url_private_html'], 'String');
      if (data.hasOwnProperty('url_private_api'))
        obj.urlPrivateApi = ApiClient.convertToType(data['url_private_api'], 'String');
      if (data.hasOwnProperty('timeline'))
        obj.timeline = Timeline.constructFromObject(data['timeline']);
      if (data.hasOwnProperty('thumb'))
        obj.thumb = ApiClient.convertToType(data['thumb'], 'String');
      if (data.hasOwnProperty('defined_type'))
        obj.definedType = ApiClient.convertToType(data['defined_type'], 'Number');
      if (data.hasOwnProperty('defined_type_name'))
        obj.definedTypeName = ApiClient.convertToType(data['defined_type_name'], 'String');
    }
    return obj;
  }

  /**
   * Unique identifier for article
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Title of article
   * @member {String} title
   */
  exports.prototype.title = undefined;

  /**
   * DOI
   * @member {String} doi
   */
  exports.prototype.doi = undefined;

  /**
   * Handle
   * @member {String} handle
   */
  exports.prototype.handle = undefined;

  /**
   * Api endpoint for article
   * @member {String} url
   */
  exports.prototype.url = undefined;

  /**
   * Public site endpoint for article
   * @member {String} urlPublicHtml
   */
  exports.prototype.urlPublicHtml = undefined;

  /**
   * Public Api endpoint for article
   * @member {String} urlPublicApi
   */
  exports.prototype.urlPublicApi = undefined;

  /**
   * Private site endpoint for article
   * @member {String} urlPrivateHtml
   */
  exports.prototype.urlPrivateHtml = undefined;

  /**
   * Private Api endpoint for article
   * @member {String} urlPrivateApi
   */
  exports.prototype.urlPrivateApi = undefined;

  /**
   * Various timeline dates
   * @member {module:model/Timeline} timeline
   */
  exports.prototype.timeline = undefined;

  /**
   * Thumbnail image
   * @member {String} thumb
   */
  exports.prototype.thumb = undefined;

  /**
   * Type of article identifier
   * @member {Number} definedType
   */
  exports.prototype.definedType = undefined;

  /**
   * Name of the article type identifier
   * @member {String} definedTypeName
   */
  exports.prototype.definedTypeName = undefined;


  return exports;

}));
