/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ArticleEmbargo = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The ArticleEmbargo model module.
   * @module model/ArticleEmbargo
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ArticleEmbargo</code>.
   * @alias module:model/ArticleEmbargo
   * @class
   * @param isEmbargoed {Boolean} True if embargoed
   * @param embargoTitle {String} Title for embargo
   * @param embargoReason {String} Reason for embargo
   * @param embargoOptions {Array.<Object>} List of embargo permissions that are associated with the article. If the type is logged_in and the group_ids list is empty, then the whole institution can see the article; if there are multiple group_ids, then only users that are under those groups can see the article.
   */
  var exports = function(isEmbargoed, embargoTitle, embargoReason, embargoOptions) {
    this.isEmbargoed = isEmbargoed;
    this.embargoTitle = embargoTitle;
    this.embargoReason = embargoReason;
    this.embargoOptions = embargoOptions;
  };

  /**
   * Constructs a <code>ArticleEmbargo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ArticleEmbargo} obj Optional instance to populate.
   * @return {module:model/ArticleEmbargo} The populated <code>ArticleEmbargo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('is_embargoed'))
        obj.isEmbargoed = ApiClient.convertToType(data['is_embargoed'], 'Boolean');
      if (data.hasOwnProperty('embargo_title'))
        obj.embargoTitle = ApiClient.convertToType(data['embargo_title'], 'String');
      if (data.hasOwnProperty('embargo_reason'))
        obj.embargoReason = ApiClient.convertToType(data['embargo_reason'], 'String');
      if (data.hasOwnProperty('embargo_options'))
        obj.embargoOptions = ApiClient.convertToType(data['embargo_options'], [Object]);
    }
    return obj;
  }

  /**
   * True if embargoed
   * @member {Boolean} isEmbargoed
   */
  exports.prototype.isEmbargoed = undefined;

  /**
   * Title for embargo
   * @member {String} embargoTitle
   */
  exports.prototype.embargoTitle = undefined;

  /**
   * Reason for embargo
   * @member {String} embargoReason
   */
  exports.prototype.embargoReason = undefined;

  /**
   * List of embargo permissions that are associated with the article. If the type is logged_in and the group_ids list is empty, then the whole institution can see the article; if there are multiple group_ids, then only users that are under those groups can see the article.
   * @member {Array.<Object>} embargoOptions
   */
  exports.prototype.embargoOptions = undefined;


  return exports;

}));
