/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ArticleEmbargoUpdater = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The ArticleEmbargoUpdater model module.
   * @module model/ArticleEmbargoUpdater
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ArticleEmbargoUpdater</code>.
   * @alias module:model/ArticleEmbargoUpdater
   * @class
   * @param isEmbargoed {Boolean} Embargo status
   * @param embargoDate {String} Date when the embargo expires and the article gets published, '0' value will set up permanent embargo
   * @param embargoType {module:model/ArticleEmbargoUpdater.EmbargoTypeEnum} Embargo can be enabled at the article or the file level. Possible values: article, file
   */
  var exports = function(isEmbargoed, embargoDate, embargoType) {
    this.isEmbargoed = isEmbargoed;
    this.embargoDate = embargoDate;
    this.embargoType = embargoType;
  };

  /**
   * Constructs a <code>ArticleEmbargoUpdater</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ArticleEmbargoUpdater} obj Optional instance to populate.
   * @return {module:model/ArticleEmbargoUpdater} The populated <code>ArticleEmbargoUpdater</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('is_embargoed'))
        obj.isEmbargoed = ApiClient.convertToType(data['is_embargoed'], 'Boolean');
      if (data.hasOwnProperty('embargo_date'))
        obj.embargoDate = ApiClient.convertToType(data['embargo_date'], 'String');
      if (data.hasOwnProperty('embargo_type'))
        obj.embargoType = ApiClient.convertToType(data['embargo_type'], 'String');
      if (data.hasOwnProperty('embargo_title'))
        obj.embargoTitle = ApiClient.convertToType(data['embargo_title'], 'String');
      if (data.hasOwnProperty('embargo_reason'))
        obj.embargoReason = ApiClient.convertToType(data['embargo_reason'], 'String');
      if (data.hasOwnProperty('embargo_options'))
        obj.embargoOptions = ApiClient.convertToType(data['embargo_options'], [Object]);
    }
    return obj;
  }

  /**
   * Embargo status
   * @member {Boolean} isEmbargoed
   */
  exports.prototype.isEmbargoed = undefined;

  /**
   * Date when the embargo expires and the article gets published, '0' value will set up permanent embargo
   * @member {String} embargoDate
   */
  exports.prototype.embargoDate = undefined;

  /**
   * Embargo can be enabled at the article or the file level. Possible values: article, file
   * @member {module:model/ArticleEmbargoUpdater.EmbargoTypeEnum} embargoType
   */
  exports.prototype.embargoType = undefined;

  /**
   * Title for embargo
   * @member {String} embargoTitle
   */
  exports.prototype.embargoTitle = undefined;

  /**
   * Reason for setting embargo
   * @member {String} embargoReason
   */
  exports.prototype.embargoReason = undefined;

  /**
   * List of embargo permissions to be associated with the article. The list must contain `id` and can also contain `group_ids`(a field that only applies to 'logged_in' permissions). The new list replaces old options in the database, and an empty list removes all permissions for this article. Administration permission has to be set up alone but logged in and IP range permissions can be set up together.
   * @member {Array.<Object>} embargoOptions
   */
  exports.prototype.embargoOptions = undefined;



  /**
   * Allowed values for the <code>embargoType</code> property.
   * @enum {String}
   * @readonly
   */
  exports.EmbargoTypeEnum = {
    /**
     * value: "article"
     * @const
     */
    article: "article",

    /**
     * value: "file"
     * @const
     */
    file: "file"
  };

  return exports;

}));
