/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Article', 'model/Timeline'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Article'), require('./Timeline'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ArticleWithProject = factory(root.FigshareApi.ApiClient, root.FigshareApi.Article, root.FigshareApi.Timeline);
  }
}(this, function(ApiClient, Article, Timeline) {
  'use strict';

  /**
   * The ArticleWithProject model module.
   * @module model/ArticleWithProject
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ArticleWithProject</code>.
   * @alias module:model/ArticleWithProject
   * @class
   * @extends module:model/Article
   * @implements module:model/Article
   * @param id {Number} Unique identifier for article
   * @param title {String} Title of article
   * @param doi {String} DOI
   * @param handle {String} Handle
   * @param url {String} Api endpoint for article
   * @param urlPublicHtml {String} Public site endpoint for article
   * @param urlPublicApi {String} Public Api endpoint for article
   * @param urlPrivateHtml {String} Private site endpoint for article
   * @param urlPrivateApi {String} Private Api endpoint for article
   * @param timeline {module:model/Timeline} Various timeline dates
   * @param thumb {String} Thumbnail image
   * @param definedType {Number} Type of article identifier
   * @param definedTypeName {String} Name of the article type identifier
   */
  var exports = function(id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName) {
    Article.call(this, id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName);
    Article.call(this, id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName);
    this.projectId = projectId;
  };

  /**
   * Constructs a <code>ArticleWithProject</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ArticleWithProject} obj Optional instance to populate.
   * @return {module:model/ArticleWithProject} The populated <code>ArticleWithProject</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      Article.constructFromObject(data, obj);
      Article.constructFromObject(data, obj);
      if (data.hasOwnProperty('project_id'))
        obj.projectId = ApiClient.convertToType(data['project_id'], 'Number');
    }
    return obj;
  }

  exports.prototype = Object.create(Article.prototype);
  exports.prototype.constructor = exports;
  /**
   * Project id for this article.
   * @member {Number} projectId
   * @default 0
   */
  exports.prototype.projectId = 0;


  // Implement Article interface:
  /**
   * Unique identifier for article
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Title of article
   * @member {String} title
   */
  exports.prototype.title = undefined;

  /**
   * DOI
   * @member {String} doi
   */
  exports.prototype.doi = undefined;

  /**
   * Handle
   * @member {String} handle
   */
  exports.prototype.handle = undefined;

  /**
   * Api endpoint for article
   * @member {String} url
   */
  exports.prototype.url = undefined;

  /**
   * Public site endpoint for article
   * @member {String} urlPublicHtml
   */
  exports.prototype.urlPublicHtml = undefined;

  /**
   * Public Api endpoint for article
   * @member {String} urlPublicApi
   */
  exports.prototype.urlPublicApi = undefined;

  /**
   * Private site endpoint for article
   * @member {String} urlPrivateHtml
   */
  exports.prototype.urlPrivateHtml = undefined;

  /**
   * Private Api endpoint for article
   * @member {String} urlPrivateApi
   */
  exports.prototype.urlPrivateApi = undefined;

  /**
   * Various timeline dates
   * @member {module:model/Timeline} timeline
   */
  exports.prototype.timeline = undefined;

  /**
   * Thumbnail image
   * @member {String} thumb
   */
  exports.prototype.thumb = undefined;

  /**
   * Type of article identifier
   * @member {Number} definedType
   */
  exports.prototype.definedType = undefined;

  /**
   * Name of the article type identifier
   * @member {String} definedTypeName
   */
  exports.prototype.definedTypeName = undefined;

  return exports;

}));
