/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Author'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Author'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.AuthorComplete = factory(root.FigshareApi.ApiClient, root.FigshareApi.Author);
  }
}(this, function(ApiClient, Author) {
  'use strict';

  /**
   * The AuthorComplete model module.
   * @module model/AuthorComplete
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>AuthorComplete</code>.
   * @alias module:model/AuthorComplete
   * @class
   * @extends module:model/Author
   * @implements module:model/Author
   * @param id {Number} Author id
   * @param fullName {String} Author full name
   * @param isActive {Boolean} True if author has published items
   * @param urlName {String} Author url name
   * @param orcidId {String} Author Orcid
   */
  var exports = function(id, fullName, isActive, urlName, orcidId) {
    Author.call(this, id, fullName, isActive, urlName, orcidId);
    Author.call(this, id, fullName, isActive, urlName, orcidId);
    this.institutionId = institutionId;
    this.groupId = groupId;
    this.firstName = firstName;
    this.lastName = lastName;
    this.isPublic = isPublic;
    this.jobTitle = jobTitle;
  };

  /**
   * Constructs a <code>AuthorComplete</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AuthorComplete} obj Optional instance to populate.
   * @return {module:model/AuthorComplete} The populated <code>AuthorComplete</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      Author.constructFromObject(data, obj);
      Author.constructFromObject(data, obj);
      if (data.hasOwnProperty('institution_id'))
        obj.institutionId = ApiClient.convertToType(data['institution_id'], 'Number');
      if (data.hasOwnProperty('group_id'))
        obj.groupId = ApiClient.convertToType(data['group_id'], 'Number');
      if (data.hasOwnProperty('first_name'))
        obj.firstName = ApiClient.convertToType(data['first_name'], 'String');
      if (data.hasOwnProperty('last_name'))
        obj.lastName = ApiClient.convertToType(data['last_name'], 'String');
      if (data.hasOwnProperty('is_public'))
        obj.isPublic = ApiClient.convertToType(data['is_public'], 'Number');
      if (data.hasOwnProperty('job_title'))
        obj.jobTitle = ApiClient.convertToType(data['job_title'], 'String');
    }
    return obj;
  }

  exports.prototype = Object.create(Author.prototype);
  exports.prototype.constructor = exports;
  /**
   * Institution id
   * @member {Number} institutionId
   */
  exports.prototype.institutionId = undefined;

  /**
   * Group id
   * @member {Number} groupId
   */
  exports.prototype.groupId = undefined;

  /**
   * First Name
   * @member {String} firstName
   */
  exports.prototype.firstName = undefined;

  /**
   * Last Name
   * @member {String} lastName
   */
  exports.prototype.lastName = undefined;

  /**
   * if 1 then the author has published items
   * @member {Number} isPublic
   */
  exports.prototype.isPublic = undefined;

  /**
   * Job title
   * @member {String} jobTitle
   */
  exports.prototype.jobTitle = undefined;


  // Implement Author interface:
  /**
   * Author id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Author full name
   * @member {String} fullName
   */
  exports.prototype.fullName = undefined;

  /**
   * True if author has published items
   * @member {Boolean} isActive
   */
  exports.prototype.isActive = undefined;

  /**
   * Author url name
   * @member {String} urlName
   */
  exports.prototype.urlName = undefined;

  /**
   * Author Orcid
   * @member {String} orcidId
   */
  exports.prototype.orcidId = undefined;

  return exports;

}));
