/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.Category = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The Category model module.
   * @module model/Category
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>Category</code>.
   * @alias module:model/Category
   * @class
   * @param parentId {Number} Parent category
   * @param id {Number} Category id
   * @param title {String} Category title
   * @param path {String} Path to all ancestor ids
   * @param sourceId {String} ID in original standard taxonomy
   * @param taxonomyId {Number} Internal id of taxonomy the category is part of
   */
  var exports = function(parentId, id, title, path, sourceId, taxonomyId) {
    this.parentId = parentId;
    this.id = id;
    this.title = title;
    this.path = path;
    this.sourceId = sourceId;
    this.taxonomyId = taxonomyId;
  };

  /**
   * Constructs a <code>Category</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Category} obj Optional instance to populate.
   * @return {module:model/Category} The populated <code>Category</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('parent_id'))
        obj.parentId = ApiClient.convertToType(data['parent_id'], 'Number');
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('title'))
        obj.title = ApiClient.convertToType(data['title'], 'String');
      if (data.hasOwnProperty('path'))
        obj.path = ApiClient.convertToType(data['path'], 'String');
      if (data.hasOwnProperty('source_id'))
        obj.sourceId = ApiClient.convertToType(data['source_id'], 'String');
      if (data.hasOwnProperty('taxonomy_id'))
        obj.taxonomyId = ApiClient.convertToType(data['taxonomy_id'], 'Number');
    }
    return obj;
  }

  /**
   * Parent category
   * @member {Number} parentId
   */
  exports.prototype.parentId = undefined;

  /**
   * Category id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Category title
   * @member {String} title
   */
  exports.prototype.title = undefined;

  /**
   * Path to all ancestor ids
   * @member {String} path
   */
  exports.prototype.path = undefined;

  /**
   * ID in original standard taxonomy
   * @member {String} sourceId
   */
  exports.prototype.sourceId = undefined;

  /**
   * Internal id of taxonomy the category is part of
   * @member {Number} taxonomyId
   */
  exports.prototype.taxonomyId = undefined;


  return exports;

}));
