/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.Collaborator = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The Collaborator model module.
   * @module model/Collaborator
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>Collaborator</code>.
   * @alias module:model/Collaborator
   * @class
   * @param roleName {String} Collaborator role
   * @param userId {Number} Collaborator id
   * @param name {String} Collaborator name
   */
  var exports = function(roleName, userId, name) {
    this.roleName = roleName;
    this.userId = userId;
    this.name = name;
  };

  /**
   * Constructs a <code>Collaborator</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Collaborator} obj Optional instance to populate.
   * @return {module:model/Collaborator} The populated <code>Collaborator</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('role_name'))
        obj.roleName = ApiClient.convertToType(data['role_name'], 'String');
      if (data.hasOwnProperty('user_id'))
        obj.userId = ApiClient.convertToType(data['user_id'], 'Number');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
    }
    return obj;
  }

  /**
   * Collaborator role
   * @member {String} roleName
   */
  exports.prototype.roleName = undefined;

  /**
   * Collaborator id
   * @member {Number} userId
   */
  exports.prototype.userId = undefined;

  /**
   * Collaborator name
   * @member {String} name
   */
  exports.prototype.name = undefined;


  return exports;

}));
