/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Timeline'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Timeline'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.Collection = factory(root.FigshareApi.ApiClient, root.FigshareApi.Timeline);
  }
}(this, function(ApiClient, Timeline) {
  'use strict';

  /**
   * The Collection model module.
   * @module model/Collection
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>Collection</code>.
   * @alias module:model/Collection
   * @class
   * @param id {Number} Collection id
   * @param title {String} Collection title
   * @param doi {String} Collection DOI
   * @param handle {String} Collection Handle
   * @param url {String} Api endpoint
   * @param timeline {module:model/Timeline} Various timeline dates
   */
  var exports = function(id, title, doi, handle, url, timeline) {
    this.id = id;
    this.title = title;
    this.doi = doi;
    this.handle = handle;
    this.url = url;
    this.timeline = timeline;
  };

  /**
   * Constructs a <code>Collection</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Collection} obj Optional instance to populate.
   * @return {module:model/Collection} The populated <code>Collection</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('title'))
        obj.title = ApiClient.convertToType(data['title'], 'String');
      if (data.hasOwnProperty('doi'))
        obj.doi = ApiClient.convertToType(data['doi'], 'String');
      if (data.hasOwnProperty('handle'))
        obj.handle = ApiClient.convertToType(data['handle'], 'String');
      if (data.hasOwnProperty('url'))
        obj.url = ApiClient.convertToType(data['url'], 'String');
      if (data.hasOwnProperty('timeline'))
        obj.timeline = Timeline.constructFromObject(data['timeline']);
    }
    return obj;
  }

  /**
   * Collection id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Collection title
   * @member {String} title
   */
  exports.prototype.title = undefined;

  /**
   * Collection DOI
   * @member {String} doi
   */
  exports.prototype.doi = undefined;

  /**
   * Collection Handle
   * @member {String} handle
   */
  exports.prototype.handle = undefined;

  /**
   * Api endpoint
   * @member {String} url
   */
  exports.prototype.url = undefined;

  /**
   * Various timeline dates
   * @member {module:model/Timeline} timeline
   */
  exports.prototype.timeline = undefined;


  return exports;

}));
