/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CommonSearch'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CommonSearch'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.CollectionSearch = factory(root.FigshareApi.ApiClient, root.FigshareApi.CommonSearch);
  }
}(this, function(ApiClient, CommonSearch) {
  'use strict';

  /**
   * The CollectionSearch model module.
   * @module model/CollectionSearch
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>CollectionSearch</code>.
   * @alias module:model/CollectionSearch
   * @class
   * @extends module:model/CommonSearch
   * @implements module:model/CommonSearch
   */
  var exports = function() {
    CommonSearch.call(this);
    CommonSearch.call(this);
  };

  /**
   * Constructs a <code>CollectionSearch</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CollectionSearch} obj Optional instance to populate.
   * @return {module:model/CollectionSearch} The populated <code>CollectionSearch</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      CommonSearch.constructFromObject(data, obj);
      CommonSearch.constructFromObject(data, obj);
      if (data.hasOwnProperty('resource_doi'))
        obj.resourceDoi = ApiClient.convertToType(data['resource_doi'], 'String');
      if (data.hasOwnProperty('doi'))
        obj.doi = ApiClient.convertToType(data['doi'], 'String');
      if (data.hasOwnProperty('handle'))
        obj.handle = ApiClient.convertToType(data['handle'], 'String');
      if (data.hasOwnProperty('order'))
        obj.order = ApiClient.convertToType(data['order'], 'String');
    }
    return obj;
  }

  exports.prototype = Object.create(CommonSearch.prototype);
  exports.prototype.constructor = exports;
  /**
   * Only return collections with this resource_doi
   * @member {String} resourceDoi
   */
  exports.prototype.resourceDoi = undefined;

  /**
   * Only return collections with this doi
   * @member {String} doi
   */
  exports.prototype.doi = undefined;

  /**
   * Only return collections with this handle
   * @member {String} handle
   */
  exports.prototype.handle = undefined;

  /**
   * The field by which to order.
   * @member {module:model/CollectionSearch.OrderEnum} order
   * @default 'created_date'
   */
  exports.prototype.order = 'created_date';


  // Implement CommonSearch interface:
  /**
   * Search term
   * @member {String} searchFor
   */
  exports.prototype.searchFor = undefined;

  /**
   * Page number. Used for pagination with page_size
   * @member {Number} page
   */
  exports.prototype.page = undefined;

  /**
   * The number of results included on a page. Used for pagination with page
   * @member {Number} pageSize
   * @default 10
   */
  exports.prototype.pageSize = 10;

  /**
   * Number of results included on a page. Used for pagination with query
   * @member {Number} limit
   */
  exports.prototype.limit = undefined;

  /**
   * Where to start the listing(the offset of the first result). Used for pagination with limit
   * @member {Number} offset
   */
  exports.prototype.offset = undefined;

  /**
   * Direction of ordering
   * @member {module:model/CommonSearch.OrderDirectionEnum} orderDirection
   * @default 'desc'
   */
  exports.prototype.orderDirection = 'desc';

  /**
   * only return collections from this institution
   * @member {Number} institution
   */
  exports.prototype.institution = undefined;

  /**
   * Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @member {String} publishedSince
   */
  exports.prototype.publishedSince = undefined;

  /**
   * Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @member {String} modifiedSince
   */
  exports.prototype.modifiedSince = undefined;

  /**
   * only return collections from this group
   * @member {Number} group
   */
  exports.prototype.group = undefined;


  /**
   * Allowed values for the <code>order</code> property.
   * @enum {String}
   * @readonly
   */
  exports.OrderEnum = {
    /**
     * value: "created_date"
     * @const
     */
    createdDate: "created_date",

    /**
     * value: "published_date"
     * @const
     */
    publishedDate: "published_date",

    /**
     * value: "modified_date"
     * @const
     */
    modifiedDate: "modified_date",

    /**
     * value: "views"
     * @const
     */
    views: "views",

    /**
     * value: "shares"
     * @const
     */
    shares: "shares",

    /**
     * value: "cites"
     * @const
     */
    cites: "cites"
  };

  return exports;

}));
