/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.CommonSearch = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The CommonSearch model module.
   * @module model/CommonSearch
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>CommonSearch</code>.
   * @alias module:model/CommonSearch
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>CommonSearch</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CommonSearch} obj Optional instance to populate.
   * @return {module:model/CommonSearch} The populated <code>CommonSearch</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('search_for'))
        obj.searchFor = ApiClient.convertToType(data['search_for'], 'String');
      if (data.hasOwnProperty('page'))
        obj.page = ApiClient.convertToType(data['page'], 'Number');
      if (data.hasOwnProperty('page_size'))
        obj.pageSize = ApiClient.convertToType(data['page_size'], 'Number');
      if (data.hasOwnProperty('limit'))
        obj.limit = ApiClient.convertToType(data['limit'], 'Number');
      if (data.hasOwnProperty('offset'))
        obj.offset = ApiClient.convertToType(data['offset'], 'Number');
      if (data.hasOwnProperty('order_direction'))
        obj.orderDirection = ApiClient.convertToType(data['order_direction'], 'String');
      if (data.hasOwnProperty('institution'))
        obj.institution = ApiClient.convertToType(data['institution'], 'Number');
      if (data.hasOwnProperty('published_since'))
        obj.publishedSince = ApiClient.convertToType(data['published_since'], 'String');
      if (data.hasOwnProperty('modified_since'))
        obj.modifiedSince = ApiClient.convertToType(data['modified_since'], 'String');
      if (data.hasOwnProperty('group'))
        obj.group = ApiClient.convertToType(data['group'], 'Number');
    }
    return obj;
  }

  /**
   * Search term
   * @member {String} searchFor
   */
  exports.prototype.searchFor = undefined;

  /**
   * Page number. Used for pagination with page_size
   * @member {Number} page
   */
  exports.prototype.page = undefined;

  /**
   * The number of results included on a page. Used for pagination with page
   * @member {Number} pageSize
   * @default 10
   */
  exports.prototype.pageSize = 10;

  /**
   * Number of results included on a page. Used for pagination with query
   * @member {Number} limit
   */
  exports.prototype.limit = undefined;

  /**
   * Where to start the listing(the offset of the first result). Used for pagination with limit
   * @member {Number} offset
   */
  exports.prototype.offset = undefined;

  /**
   * Direction of ordering
   * @member {module:model/CommonSearch.OrderDirectionEnum} orderDirection
   * @default 'desc'
   */
  exports.prototype.orderDirection = 'desc';

  /**
   * only return collections from this institution
   * @member {Number} institution
   */
  exports.prototype.institution = undefined;

  /**
   * Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @member {String} publishedSince
   */
  exports.prototype.publishedSince = undefined;

  /**
   * Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @member {String} modifiedSince
   */
  exports.prototype.modifiedSince = undefined;

  /**
   * only return collections from this group
   * @member {Number} group
   */
  exports.prototype.group = undefined;



  /**
   * Allowed values for the <code>orderDirection</code> property.
   * @enum {String}
   * @readonly
   */
  exports.OrderDirectionEnum = {
    /**
     * value: "asc"
     * @const
     */
    asc: "asc",

    /**
     * value: "desc"
     * @const
     */
    desc: "desc"
  };

  return exports;

}));
