/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.Curation = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The Curation model module.
   * @module model/Curation
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>Curation</code>.
   * @alias module:model/Curation
   * @class
   * @param id {Number} The review id
   * @param groupId {Number} The group in which the article is present.
   * @param accountId {Number} The ID of the account of the owner of the article of this review.
   * @param assignedTo {Number} The ID of the account to which this review is assigned.
   * @param articleId {Number} The ID of the article of this review.
   * @param version {Number} The Version number of the article in review.
   * @param commentsCount {Number} The number of comments in the review.
   * @param status {module:model/Curation.StatusEnum} The status of the review.
   * @param createdDate {String} The creation date of the review.
   * @param modifiedDate {String} The date the review has been modified.
   */
  var exports = function(id, groupId, accountId, assignedTo, articleId, version, commentsCount, status, createdDate, modifiedDate) {
    this.id = id;
    this.groupId = groupId;
    this.accountId = accountId;
    this.assignedTo = assignedTo;
    this.articleId = articleId;
    this.version = version;
    this.commentsCount = commentsCount;
    this.status = status;
    this.createdDate = createdDate;
    this.modifiedDate = modifiedDate;
  };

  /**
   * Constructs a <code>Curation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Curation} obj Optional instance to populate.
   * @return {module:model/Curation} The populated <code>Curation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('group_id'))
        obj.groupId = ApiClient.convertToType(data['group_id'], 'Number');
      if (data.hasOwnProperty('account_id'))
        obj.accountId = ApiClient.convertToType(data['account_id'], 'Number');
      if (data.hasOwnProperty('assigned_to'))
        obj.assignedTo = ApiClient.convertToType(data['assigned_to'], 'Number');
      if (data.hasOwnProperty('article_id'))
        obj.articleId = ApiClient.convertToType(data['article_id'], 'Number');
      if (data.hasOwnProperty('version'))
        obj.version = ApiClient.convertToType(data['version'], 'Number');
      if (data.hasOwnProperty('comments_count'))
        obj.commentsCount = ApiClient.convertToType(data['comments_count'], 'Number');
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('created_date'))
        obj.createdDate = ApiClient.convertToType(data['created_date'], 'String');
      if (data.hasOwnProperty('modified_date'))
        obj.modifiedDate = ApiClient.convertToType(data['modified_date'], 'String');
    }
    return obj;
  }

  /**
   * The review id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The group in which the article is present.
   * @member {Number} groupId
   */
  exports.prototype.groupId = undefined;

  /**
   * The ID of the account of the owner of the article of this review.
   * @member {Number} accountId
   */
  exports.prototype.accountId = undefined;

  /**
   * The ID of the account to which this review is assigned.
   * @member {Number} assignedTo
   */
  exports.prototype.assignedTo = undefined;

  /**
   * The ID of the article of this review.
   * @member {Number} articleId
   */
  exports.prototype.articleId = undefined;

  /**
   * The Version number of the article in review.
   * @member {Number} version
   */
  exports.prototype.version = undefined;

  /**
   * The number of comments in the review.
   * @member {Number} commentsCount
   */
  exports.prototype.commentsCount = undefined;

  /**
   * The status of the review.
   * @member {module:model/Curation.StatusEnum} status
   */
  exports.prototype.status = undefined;

  /**
   * The creation date of the review.
   * @member {String} createdDate
   */
  exports.prototype.createdDate = undefined;

  /**
   * The date the review has been modified.
   * @member {String} modifiedDate
   */
  exports.prototype.modifiedDate = undefined;



  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "pending"
     * @const
     */
    pending: "pending",

    /**
     * value: "approved"
     * @const
     */
    approved: "approved",

    /**
     * value: "rejected"
     * @const
     */
    rejected: "rejected",

    /**
     * value: "closed"
     * @const
     */
    closed: "closed"
  };

  return exports;

}));
