/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.CurationComment = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The CurationComment model module.
   * @module model/CurationComment
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>CurationComment</code>.
   * @alias module:model/CurationComment
   * @class
   * @param id {Number} The ID of the comment.
   * @param accountId {Number} The ID of the account which generated this comment.
   * @param type {module:model/CurationComment.TypeEnum} The ID of the account which generated this comment.
   * @param text {String} The value/content of the comment.
   */
  var exports = function(id, accountId, type, text) {
    this.id = id;
    this.accountId = accountId;
    this.type = type;
    this.text = text;
  };

  /**
   * Constructs a <code>CurationComment</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CurationComment} obj Optional instance to populate.
   * @return {module:model/CurationComment} The populated <code>CurationComment</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('account_id'))
        obj.accountId = ApiClient.convertToType(data['account_id'], 'Number');
      if (data.hasOwnProperty('type'))
        obj.type = ApiClient.convertToType(data['type'], 'String');
      if (data.hasOwnProperty('text'))
        obj.text = ApiClient.convertToType(data['text'], 'String');
    }
    return obj;
  }

  /**
   * The ID of the comment.
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The ID of the account which generated this comment.
   * @member {Number} accountId
   */
  exports.prototype.accountId = undefined;

  /**
   * The ID of the account which generated this comment.
   * @member {module:model/CurationComment.TypeEnum} type
   */
  exports.prototype.type = undefined;

  /**
   * The value/content of the comment.
   * @member {String} text
   */
  exports.prototype.text = undefined;



  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "comment"
     * @const
     */
    comment: "comment",

    /**
     * value: "approved"
     * @const
     */
    approved: "approved",

    /**
     * value: "rejected"
     * @const
     */
    rejected: "rejected",

    /**
     * value: "closed"
     * @const
     */
    closed: "closed"
  };

  return exports;

}));
