/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ArticleComplete', 'model/Curation'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ArticleComplete'), require('./Curation'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.CurationDetail = factory(root.FigshareApi.ApiClient, root.FigshareApi.ArticleComplete, root.FigshareApi.Curation);
  }
}(this, function(ApiClient, ArticleComplete, Curation) {
  'use strict';

  /**
   * The CurationDetail model module.
   * @module model/CurationDetail
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>CurationDetail</code>.
   * @alias module:model/CurationDetail
   * @class
   * @extends module:model/Curation
   * @implements module:model/Curation
   * @param id {Number} The review id
   * @param groupId {Number} The group in which the article is present.
   * @param accountId {Number} The ID of the account of the owner of the article of this review.
   * @param assignedTo {Number} The ID of the account to which this review is assigned.
   * @param articleId {Number} The ID of the article of this review.
   * @param version {Number} The Version number of the article in review.
   * @param commentsCount {Number} The number of comments in the review.
   * @param status {module:model/Curation.StatusEnum} The status of the review.
   * @param createdDate {String} The creation date of the review.
   * @param modifiedDate {String} The date the review has been modified.
   */
  var exports = function(id, groupId, accountId, assignedTo, articleId, version, commentsCount, status, createdDate, modifiedDate) {
    Curation.call(this, id, groupId, accountId, assignedTo, articleId, version, commentsCount, status, createdDate, modifiedDate);
    Curation.call(this, id, groupId, accountId, assignedTo, articleId, version, commentsCount, status, createdDate, modifiedDate);
    this.item = item;
  };

  /**
   * Constructs a <code>CurationDetail</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CurationDetail} obj Optional instance to populate.
   * @return {module:model/CurationDetail} The populated <code>CurationDetail</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      Curation.constructFromObject(data, obj);
      Curation.constructFromObject(data, obj);
      if (data.hasOwnProperty('item'))
        obj.item = ArticleComplete.constructFromObject(data['item']);
    }
    return obj;
  }

  exports.prototype = Object.create(Curation.prototype);
  exports.prototype.constructor = exports;
  /**
   * Article details
   * @member {module:model/ArticleComplete} item
   */
  exports.prototype.item = undefined;


  // Implement Curation interface:
  /**
   * The review id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The group in which the article is present.
   * @member {Number} groupId
   */
  exports.prototype.groupId = undefined;

  /**
   * The ID of the account of the owner of the article of this review.
   * @member {Number} accountId
   */
  exports.prototype.accountId = undefined;

  /**
   * The ID of the account to which this review is assigned.
   * @member {Number} assignedTo
   */
  exports.prototype.assignedTo = undefined;

  /**
   * The ID of the article of this review.
   * @member {Number} articleId
   */
  exports.prototype.articleId = undefined;

  /**
   * The Version number of the article in review.
   * @member {Number} version
   */
  exports.prototype.version = undefined;

  /**
   * The number of comments in the review.
   * @member {Number} commentsCount
   */
  exports.prototype.commentsCount = undefined;

  /**
   * The status of the review.
   * @member {module:model/Curation.StatusEnum} status
   */
  exports.prototype.status = undefined;

  /**
   * The creation date of the review.
   * @member {String} createdDate
   */
  exports.prototype.createdDate = undefined;

  /**
   * The date the review has been modified.
   * @member {String} modifiedDate
   */
  exports.prototype.modifiedDate = undefined;

  return exports;

}));
