/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.FundingInformation = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The FundingInformation model module.
   * @module model/FundingInformation
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>FundingInformation</code>.
   * @alias module:model/FundingInformation
   * @class
   * @param id {Number} Funding id
   * @param title {String} The funding name
   * @param grantCode {String} The grant code
   * @param funderName {String} Funder's name
   * @param isUserDefined {Number} Return 1 whether the grant has been introduced manually, 0 otherwise
   * @param url {String} The grant url
   */
  var exports = function(id, title, grantCode, funderName, isUserDefined, url) {
    this.id = id;
    this.title = title;
    this.grantCode = grantCode;
    this.funderName = funderName;
    this.isUserDefined = isUserDefined;
    this.url = url;
  };

  /**
   * Constructs a <code>FundingInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FundingInformation} obj Optional instance to populate.
   * @return {module:model/FundingInformation} The populated <code>FundingInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('title'))
        obj.title = ApiClient.convertToType(data['title'], 'String');
      if (data.hasOwnProperty('grant_code'))
        obj.grantCode = ApiClient.convertToType(data['grant_code'], 'String');
      if (data.hasOwnProperty('funder_name'))
        obj.funderName = ApiClient.convertToType(data['funder_name'], 'String');
      if (data.hasOwnProperty('is_user_defined'))
        obj.isUserDefined = ApiClient.convertToType(data['is_user_defined'], 'Number');
      if (data.hasOwnProperty('url'))
        obj.url = ApiClient.convertToType(data['url'], 'String');
    }
    return obj;
  }

  /**
   * Funding id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The funding name
   * @member {String} title
   */
  exports.prototype.title = undefined;

  /**
   * The grant code
   * @member {String} grantCode
   */
  exports.prototype.grantCode = undefined;

  /**
   * Funder's name
   * @member {String} funderName
   */
  exports.prototype.funderName = undefined;

  /**
   * Return 1 whether the grant has been introduced manually, 0 otherwise
   * @member {Number} isUserDefined
   */
  exports.prototype.isUserDefined = undefined;

  /**
   * The grant url
   * @member {String} url
   */
  exports.prototype.url = undefined;


  return exports;

}));
