/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.Group = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The Group model module.
   * @module model/Group
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>Group</code>.
   * @alias module:model/Group
   * @class
   * @param id {Number} Group id
   * @param name {String} Group name
   * @param resourceId {String} Group resource id
   * @param parentId {Number} Parent group if any
   * @param associationCriteria {String} HR code associated with group, if code exists
   */
  var exports = function(id, name, resourceId, parentId, associationCriteria) {
    this.id = id;
    this.name = name;
    this.resourceId = resourceId;
    this.parentId = parentId;
    this.associationCriteria = associationCriteria;
  };

  /**
   * Constructs a <code>Group</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Group} obj Optional instance to populate.
   * @return {module:model/Group} The populated <code>Group</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('resource_id'))
        obj.resourceId = ApiClient.convertToType(data['resource_id'], 'String');
      if (data.hasOwnProperty('parent_id'))
        obj.parentId = ApiClient.convertToType(data['parent_id'], 'Number');
      if (data.hasOwnProperty('association_criteria'))
        obj.associationCriteria = ApiClient.convertToType(data['association_criteria'], 'String');
    }
    return obj;
  }

  /**
   * Group id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Group name
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * Group resource id
   * @member {String} resourceId
   */
  exports.prototype.resourceId = undefined;

  /**
   * Parent group if any
   * @member {Number} parentId
   */
  exports.prototype.parentId = undefined;

  /**
   * HR code associated with group, if code exists
   * @member {String} associationCriteria
   */
  exports.prototype.associationCriteria = undefined;


  return exports;

}));
