/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ItemType = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The ItemType model module.
   * @module model/ItemType
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ItemType</code>.
   * @alias module:model/ItemType
   * @class
   * @param id {Number} The ID of the item type.
   * @param name {String} The name of the item type
   * @param stringId {String} The string identifier of the item type.
   * @param icon {String} The string identifying the icon of the item type.
   * @param publicDescription {String} The description of the item type.
   * @param isSelectable {Boolean} The selectable status
   * @param urlName {String} The URL name of the item type.
   */
  var exports = function(id, name, stringId, icon, publicDescription, isSelectable, urlName) {
    this.id = id;
    this.name = name;
    this.stringId = stringId;
    this.icon = icon;
    this.publicDescription = publicDescription;
    this.isSelectable = isSelectable;
    this.urlName = urlName;
  };

  /**
   * Constructs a <code>ItemType</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ItemType} obj Optional instance to populate.
   * @return {module:model/ItemType} The populated <code>ItemType</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('string_id'))
        obj.stringId = ApiClient.convertToType(data['string_id'], 'String');
      if (data.hasOwnProperty('icon'))
        obj.icon = ApiClient.convertToType(data['icon'], 'String');
      if (data.hasOwnProperty('public_description'))
        obj.publicDescription = ApiClient.convertToType(data['public_description'], 'String');
      if (data.hasOwnProperty('is_selectable'))
        obj.isSelectable = ApiClient.convertToType(data['is_selectable'], 'Boolean');
      if (data.hasOwnProperty('url_name'))
        obj.urlName = ApiClient.convertToType(data['url_name'], 'String');
    }
    return obj;
  }

  /**
   * The ID of the item type.
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The name of the item type
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * The string identifier of the item type.
   * @member {String} stringId
   */
  exports.prototype.stringId = undefined;

  /**
   * The string identifying the icon of the item type.
   * @member {String} icon
   */
  exports.prototype.icon = undefined;

  /**
   * The description of the item type.
   * @member {String} publicDescription
   */
  exports.prototype.publicDescription = undefined;

  /**
   * The selectable status
   * @member {Boolean} isSelectable
   */
  exports.prototype.isSelectable = undefined;

  /**
   * The URL name of the item type.
   * @member {String} urlName
   */
  exports.prototype.urlName = undefined;


  return exports;

}));
