/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CollectionSearch'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CollectionSearch'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.PrivateCollectionSearch = factory(root.FigshareApi.ApiClient, root.FigshareApi.CollectionSearch);
  }
}(this, function(ApiClient, CollectionSearch) {
  'use strict';

  /**
   * The PrivateCollectionSearch model module.
   * @module model/PrivateCollectionSearch
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>PrivateCollectionSearch</code>.
   * @alias module:model/PrivateCollectionSearch
   * @class
   * @extends module:model/CollectionSearch
   * @implements module:model/CollectionSearch
   */
  var exports = function() {
    CollectionSearch.call(this);
    CollectionSearch.call(this);
  };

  /**
   * Constructs a <code>PrivateCollectionSearch</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PrivateCollectionSearch} obj Optional instance to populate.
   * @return {module:model/PrivateCollectionSearch} The populated <code>PrivateCollectionSearch</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      CollectionSearch.constructFromObject(data, obj);
      CollectionSearch.constructFromObject(data, obj);
      if (data.hasOwnProperty('resource_id'))
        obj.resourceId = ApiClient.convertToType(data['resource_id'], 'String');
    }
    return obj;
  }

  exports.prototype = Object.create(CollectionSearch.prototype);
  exports.prototype.constructor = exports;
  /**
   * only return collections with this resource_id
   * @member {String} resourceId
   */
  exports.prototype.resourceId = undefined;


  // Implement CollectionSearch interface:
  /**
   * Search term
   * @member {String} searchFor
   */
  exports.prototype.searchFor = undefined;

  /**
   * Page number. Used for pagination with page_size
   * @member {Number} page
   */
  exports.prototype.page = undefined;

  /**
   * The number of results included on a page. Used for pagination with page
   * @member {Number} pageSize
   * @default 10
   */
  exports.prototype.pageSize = 10;

  /**
   * Number of results included on a page. Used for pagination with query
   * @member {Number} limit
   */
  exports.prototype.limit = undefined;

  /**
   * Where to start the listing(the offset of the first result). Used for pagination with limit
   * @member {Number} offset
   */
  exports.prototype.offset = undefined;

  /**
   * Direction of ordering
   * @member {module:model/CommonSearch.OrderDirectionEnum} orderDirection
   * @default 'desc'
   */
  exports.prototype.orderDirection = 'desc';

  /**
   * only return collections from this institution
   * @member {Number} institution
   */
  exports.prototype.institution = undefined;

  /**
   * Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @member {String} publishedSince
   */
  exports.prototype.publishedSince = undefined;

  /**
   * Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @member {String} modifiedSince
   */
  exports.prototype.modifiedSince = undefined;

  /**
   * only return collections from this group
   * @member {Number} group
   */
  exports.prototype.group = undefined;

  return exports;

}));
