/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/PublicFile'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./PublicFile'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.PrivateFile = factory(root.FigshareApi.ApiClient, root.FigshareApi.PublicFile);
  }
}(this, function(ApiClient, PublicFile) {
  'use strict';

  /**
   * The PrivateFile model module.
   * @module model/PrivateFile
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>PrivateFile</code>.
   * @alias module:model/PrivateFile
   * @class
   * @extends module:model/PublicFile
   * @implements module:model/PublicFile
   * @param id {Number} File id
   * @param name {String} File name
   * @param size {Number} File size
   * @param isLinkOnly {Boolean} True if file is hosted somewhere else
   * @param downloadUrl {String} Url for file download
   * @param suppliedMd5 {String} File supplied md5
   * @param computedMd5 {String} File computed md5
   */
  var exports = function(id, name, size, isLinkOnly, downloadUrl, suppliedMd5, computedMd5) {
    PublicFile.call(this, id, name, size, isLinkOnly, downloadUrl, suppliedMd5, computedMd5);
    PublicFile.call(this, id, name, size, isLinkOnly, downloadUrl, suppliedMd5, computedMd5);
    this.viewerType = viewerType;
    this.previewState = previewState;
    this.uploadUrl = uploadUrl;
    this.uploadToken = uploadToken;
    this.isAttachedToPublicVersion = isAttachedToPublicVersion;
  };

  /**
   * Constructs a <code>PrivateFile</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PrivateFile} obj Optional instance to populate.
   * @return {module:model/PrivateFile} The populated <code>PrivateFile</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      PublicFile.constructFromObject(data, obj);
      PublicFile.constructFromObject(data, obj);
      if (data.hasOwnProperty('viewer_type'))
        obj.viewerType = ApiClient.convertToType(data['viewer_type'], 'String');
      if (data.hasOwnProperty('preview_state'))
        obj.previewState = ApiClient.convertToType(data['preview_state'], 'String');
      if (data.hasOwnProperty('upload_url'))
        obj.uploadUrl = ApiClient.convertToType(data['upload_url'], 'String');
      if (data.hasOwnProperty('upload_token'))
        obj.uploadToken = ApiClient.convertToType(data['upload_token'], 'String');
      if (data.hasOwnProperty('is_attached_to_public_version'))
        obj.isAttachedToPublicVersion = ApiClient.convertToType(data['is_attached_to_public_version'], 'Boolean');
    }
    return obj;
  }

  exports.prototype = Object.create(PublicFile.prototype);
  exports.prototype.constructor = exports;
  /**
   * File viewer type
   * @member {String} viewerType
   */
  exports.prototype.viewerType = undefined;

  /**
   * File preview state
   * @member {String} previewState
   */
  exports.prototype.previewState = undefined;

  /**
   * Upload url for file
   * @member {String} uploadUrl
   */
  exports.prototype.uploadUrl = undefined;

  /**
   * Token for file upload
   * @member {String} uploadToken
   */
  exports.prototype.uploadToken = undefined;

  /**
   * True if the file is attached to a public item version
   * @member {Boolean} isAttachedToPublicVersion
   */
  exports.prototype.isAttachedToPublicVersion = undefined;


  // Implement PublicFile interface:
  /**
   * File id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * File name
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * File size
   * @member {Number} size
   */
  exports.prototype.size = undefined;

  /**
   * True if file is hosted somewhere else
   * @member {Boolean} isLinkOnly
   */
  exports.prototype.isLinkOnly = undefined;

  /**
   * Url for file download
   * @member {String} downloadUrl
   */
  exports.prototype.downloadUrl = undefined;

  /**
   * File supplied md5
   * @member {String} suppliedMd5
   */
  exports.prototype.suppliedMd5 = undefined;

  /**
   * File computed md5
   * @member {String} computedMd5
   */
  exports.prototype.computedMd5 = undefined;

  /**
   * MIME Type of the file, it defaults to an empty string
   * @member {String} mimetype
   */
  exports.prototype.mimetype = undefined;

  return exports;

}));
