/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Article', 'model/Category', 'model/FundingInformation', 'model/License', 'model/RelatedMaterial', 'model/Timeline'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Article'), require('./Category'), require('./FundingInformation'), require('./License'), require('./RelatedMaterial'), require('./Timeline'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ProjectArticle = factory(root.FigshareApi.ApiClient, root.FigshareApi.Article, root.FigshareApi.Category, root.FigshareApi.FundingInformation, root.FigshareApi.License, root.FigshareApi.RelatedMaterial, root.FigshareApi.Timeline);
  }
}(this, function(ApiClient, Article, Category, FundingInformation, License, RelatedMaterial, Timeline) {
  'use strict';

  /**
   * The ProjectArticle model module.
   * @module model/ProjectArticle
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ProjectArticle</code>.
   * @alias module:model/ProjectArticle
   * @class
   * @extends module:model/Article
   * @implements module:model/Article
   * @param id {Number} Unique identifier for article
   * @param title {String} Title of article
   * @param doi {String} DOI
   * @param handle {String} Handle
   * @param url {String} Api endpoint for article
   * @param urlPublicHtml {String} Public site endpoint for article
   * @param urlPublicApi {String} Public Api endpoint for article
   * @param urlPrivateHtml {String} Private site endpoint for article
   * @param urlPrivateApi {String} Private Api endpoint for article
   * @param timeline {module:model/Timeline} Various timeline dates
   * @param thumb {String} Thumbnail image
   * @param definedType {Number} Type of article identifier
   * @param definedTypeName {String} Name of the article type identifier
   */
  var exports = function(id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName) {
    Article.call(this, id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName);
    Article.call(this, id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName);
    this.citation = citation;
    this.confidentialReason = confidentialReason;
    this.isConfidential = isConfidential;
    this.size = size;
    this.funding = funding;
    this.fundingList = fundingList;
    this.tags = tags;
    this.version = version;
    this.isActive = isActive;
    this.isMetadataRecord = isMetadataRecord;
    this.metadataReason = metadataReason;
    this.status = status;
    this.description = description;
    this.isEmbargoed = isEmbargoed;
    this.isPublic = isPublic;
    this.createdDate = createdDate;
    this.hasLinkedFile = hasLinkedFile;
    this.categories = categories;
    this.license = license;
    this.embargoTitle = embargoTitle;
    this.embargoReason = embargoReason;
    this.references = references;
  };

  /**
   * Constructs a <code>ProjectArticle</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectArticle} obj Optional instance to populate.
   * @return {module:model/ProjectArticle} The populated <code>ProjectArticle</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      Article.constructFromObject(data, obj);
      Article.constructFromObject(data, obj);
      if (data.hasOwnProperty('citation'))
        obj.citation = ApiClient.convertToType(data['citation'], 'String');
      if (data.hasOwnProperty('confidential_reason'))
        obj.confidentialReason = ApiClient.convertToType(data['confidential_reason'], 'String');
      if (data.hasOwnProperty('is_confidential'))
        obj.isConfidential = ApiClient.convertToType(data['is_confidential'], 'Boolean');
      if (data.hasOwnProperty('size'))
        obj.size = ApiClient.convertToType(data['size'], 'Number');
      if (data.hasOwnProperty('funding'))
        obj.funding = ApiClient.convertToType(data['funding'], 'String');
      if (data.hasOwnProperty('funding_list'))
        obj.fundingList = ApiClient.convertToType(data['funding_list'], [FundingInformation]);
      if (data.hasOwnProperty('tags'))
        obj.tags = ApiClient.convertToType(data['tags'], ['String']);
      if (data.hasOwnProperty('version'))
        obj.version = ApiClient.convertToType(data['version'], 'Number');
      if (data.hasOwnProperty('is_active'))
        obj.isActive = ApiClient.convertToType(data['is_active'], 'Boolean');
      if (data.hasOwnProperty('is_metadata_record'))
        obj.isMetadataRecord = ApiClient.convertToType(data['is_metadata_record'], 'Boolean');
      if (data.hasOwnProperty('metadata_reason'))
        obj.metadataReason = ApiClient.convertToType(data['metadata_reason'], 'String');
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('is_embargoed'))
        obj.isEmbargoed = ApiClient.convertToType(data['is_embargoed'], 'Boolean');
      if (data.hasOwnProperty('is_public'))
        obj.isPublic = ApiClient.convertToType(data['is_public'], 'Boolean');
      if (data.hasOwnProperty('created_date'))
        obj.createdDate = ApiClient.convertToType(data['created_date'], 'String');
      if (data.hasOwnProperty('has_linked_file'))
        obj.hasLinkedFile = ApiClient.convertToType(data['has_linked_file'], 'Boolean');
      if (data.hasOwnProperty('categories'))
        obj.categories = ApiClient.convertToType(data['categories'], [Category]);
      if (data.hasOwnProperty('license'))
        obj.license = License.constructFromObject(data['license']);
      if (data.hasOwnProperty('embargo_title'))
        obj.embargoTitle = ApiClient.convertToType(data['embargo_title'], 'String');
      if (data.hasOwnProperty('embargo_reason'))
        obj.embargoReason = ApiClient.convertToType(data['embargo_reason'], 'String');
      if (data.hasOwnProperty('references'))
        obj.references = ApiClient.convertToType(data['references'], ['String']);
      if (data.hasOwnProperty('related_materials'))
        obj.relatedMaterials = ApiClient.convertToType(data['related_materials'], [RelatedMaterial]);
    }
    return obj;
  }

  exports.prototype = Object.create(Article.prototype);
  exports.prototype.constructor = exports;
  /**
   * Article citation
   * @member {String} citation
   */
  exports.prototype.citation = undefined;

  /**
   * Confidentiality reason
   * @member {String} confidentialReason
   */
  exports.prototype.confidentialReason = undefined;

  /**
   * Article Confidentiality
   * @member {Boolean} isConfidential
   */
  exports.prototype.isConfidential = undefined;

  /**
   * Article size
   * @member {Number} size
   */
  exports.prototype.size = undefined;

  /**
   * Article funding
   * @member {String} funding
   */
  exports.prototype.funding = undefined;

  /**
   * Full Article funding information
   * @member {Array.<module:model/FundingInformation>} fundingList
   */
  exports.prototype.fundingList = undefined;

  /**
   * List of article tags
   * @member {Array.<String>} tags
   */
  exports.prototype.tags = undefined;

  /**
   * Article version
   * @member {Number} version
   */
  exports.prototype.version = undefined;

  /**
   * True if article is active
   * @member {Boolean} isActive
   */
  exports.prototype.isActive = undefined;

  /**
   * True if article has no files
   * @member {Boolean} isMetadataRecord
   */
  exports.prototype.isMetadataRecord = undefined;

  /**
   * Article metadata reason
   * @member {String} metadataReason
   */
  exports.prototype.metadataReason = undefined;

  /**
   * Article status
   * @member {String} status
   */
  exports.prototype.status = undefined;

  /**
   * Article description
   * @member {String} description
   */
  exports.prototype.description = undefined;

  /**
   * True if article is embargoed
   * @member {Boolean} isEmbargoed
   */
  exports.prototype.isEmbargoed = undefined;

  /**
   * True if article is published
   * @member {Boolean} isPublic
   */
  exports.prototype.isPublic = undefined;

  /**
   * Date when article was created
   * @member {String} createdDate
   */
  exports.prototype.createdDate = undefined;

  /**
   * True if any files are linked to the article
   * @member {Boolean} hasLinkedFile
   */
  exports.prototype.hasLinkedFile = undefined;

  /**
   * List of categories selected for the article
   * @member {Array.<module:model/Category>} categories
   */
  exports.prototype.categories = undefined;

  /**
   * Article selected license
   * @member {module:model/License} license
   */
  exports.prototype.license = undefined;

  /**
   * Title for embargo
   * @member {String} embargoTitle
   */
  exports.prototype.embargoTitle = undefined;

  /**
   * Reason for embargo
   * @member {String} embargoReason
   */
  exports.prototype.embargoReason = undefined;

  /**
   * List of references
   * @member {Array.<String>} references
   */
  exports.prototype.references = undefined;

  /**
   * List of related materials; supersedes references and resource DOI/title.
   * @member {Array.<module:model/RelatedMaterial>} relatedMaterials
   */
  exports.prototype.relatedMaterials = undefined;


  // Implement Article interface:
  /**
   * Unique identifier for article
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Title of article
   * @member {String} title
   */
  exports.prototype.title = undefined;

  /**
   * DOI
   * @member {String} doi
   */
  exports.prototype.doi = undefined;

  /**
   * Handle
   * @member {String} handle
   */
  exports.prototype.handle = undefined;

  /**
   * Api endpoint for article
   * @member {String} url
   */
  exports.prototype.url = undefined;

  /**
   * Public site endpoint for article
   * @member {String} urlPublicHtml
   */
  exports.prototype.urlPublicHtml = undefined;

  /**
   * Public Api endpoint for article
   * @member {String} urlPublicApi
   */
  exports.prototype.urlPublicApi = undefined;

  /**
   * Private site endpoint for article
   * @member {String} urlPrivateHtml
   */
  exports.prototype.urlPrivateHtml = undefined;

  /**
   * Private Api endpoint for article
   * @member {String} urlPrivateApi
   */
  exports.prototype.urlPrivateApi = undefined;

  /**
   * Various timeline dates
   * @member {module:model/Timeline} timeline
   */
  exports.prototype.timeline = undefined;

  /**
   * Thumbnail image
   * @member {String} thumb
   */
  exports.prototype.thumb = undefined;

  /**
   * Type of article identifier
   * @member {Number} definedType
   */
  exports.prototype.definedType = undefined;

  /**
   * Name of the article type identifier
   * @member {String} definedTypeName
   */
  exports.prototype.definedTypeName = undefined;

  return exports;

}));
