/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Collaborator', 'model/FundingInformation', 'model/Project'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Collaborator'), require('./FundingInformation'), require('./Project'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ProjectComplete = factory(root.FigshareApi.ApiClient, root.FigshareApi.Collaborator, root.FigshareApi.FundingInformation, root.FigshareApi.Project);
  }
}(this, function(ApiClient, Collaborator, FundingInformation, Project) {
  'use strict';

  /**
   * The ProjectComplete model module.
   * @module model/ProjectComplete
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ProjectComplete</code>.
   * @alias module:model/ProjectComplete
   * @class
   * @extends module:model/Project
   * @implements module:model/Project
   * @param url {String} Api endpoint
   * @param id {Number} Project id
   * @param title {String} Project title
   */
  var exports = function(url, id, title) {
    Project.call(this, url, id, title);
    Project.call(this, url, id, title);
    this.funding = funding;
    this.fundingList = fundingList;
    this.description = description;
    this.collaborators = collaborators;
  };

  /**
   * Constructs a <code>ProjectComplete</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectComplete} obj Optional instance to populate.
   * @return {module:model/ProjectComplete} The populated <code>ProjectComplete</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      Project.constructFromObject(data, obj);
      Project.constructFromObject(data, obj);
      if (data.hasOwnProperty('funding'))
        obj.funding = ApiClient.convertToType(data['funding'], 'String');
      if (data.hasOwnProperty('funding_list'))
        obj.fundingList = ApiClient.convertToType(data['funding_list'], [FundingInformation]);
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('collaborators'))
        obj.collaborators = ApiClient.convertToType(data['collaborators'], [Collaborator]);
    }
    return obj;
  }

  exports.prototype = Object.create(Project.prototype);
  exports.prototype.constructor = exports;
  /**
   * Project funding
   * @member {String} funding
   */
  exports.prototype.funding = undefined;

  /**
   * Full Project funding information
   * @member {Array.<module:model/FundingInformation>} fundingList
   */
  exports.prototype.fundingList = undefined;

  /**
   * Project description
   * @member {String} description
   */
  exports.prototype.description = undefined;

  /**
   * List of project collaborators
   * @member {Array.<module:model/Collaborator>} collaborators
   */
  exports.prototype.collaborators = undefined;


  // Implement Project interface:
  /**
   * Api endpoint
   * @member {String} url
   */
  exports.prototype.url = undefined;

  /**
   * Project id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Project title
   * @member {String} title
   */
  exports.prototype.title = undefined;

  return exports;

}));
