/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Collaborator', 'model/CustomArticleField', 'model/FundingInformation', 'model/ProjectPrivate'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Collaborator'), require('./CustomArticleField'), require('./FundingInformation'), require('./ProjectPrivate'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ProjectCompletePrivate = factory(root.FigshareApi.ApiClient, root.FigshareApi.Collaborator, root.FigshareApi.CustomArticleField, root.FigshareApi.FundingInformation, root.FigshareApi.ProjectPrivate);
  }
}(this, function(ApiClient, Collaborator, CustomArticleField, FundingInformation, ProjectPrivate) {
  'use strict';

  /**
   * The ProjectCompletePrivate model module.
   * @module model/ProjectCompletePrivate
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ProjectCompletePrivate</code>.
   * @alias module:model/ProjectCompletePrivate
   * @class
   * @extends module:model/ProjectPrivate
   * @implements module:model/ProjectPrivate
   * @param url {String} Api endpoint
   * @param id {Number} Project id
   * @param title {String} Project title
   */
  var exports = function(url, id, title) {
    ProjectPrivate.call(this, url, id, title);
    ProjectPrivate.call(this, url, id, title);
    this.funding = funding;
    this.fundingList = fundingList;
    this.description = description;
    this.collaborators = collaborators;
    this.quota = quota;
    this.usedQuota = usedQuota;
    this.createdDate = createdDate;
    this.modifiedDate = modifiedDate;
    this.usedQuotaPrivate = usedQuotaPrivate;
    this.usedQuotaPublic = usedQuotaPublic;
    this.groupId = groupId;
    this.accountId = accountId;
    this.customFields = customFields;
  };

  /**
   * Constructs a <code>ProjectCompletePrivate</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectCompletePrivate} obj Optional instance to populate.
   * @return {module:model/ProjectCompletePrivate} The populated <code>ProjectCompletePrivate</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      ProjectPrivate.constructFromObject(data, obj);
      ProjectPrivate.constructFromObject(data, obj);
      if (data.hasOwnProperty('funding'))
        obj.funding = ApiClient.convertToType(data['funding'], 'String');
      if (data.hasOwnProperty('funding_list'))
        obj.fundingList = ApiClient.convertToType(data['funding_list'], [FundingInformation]);
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('collaborators'))
        obj.collaborators = ApiClient.convertToType(data['collaborators'], [Collaborator]);
      if (data.hasOwnProperty('quota'))
        obj.quota = ApiClient.convertToType(data['quota'], 'Number');
      if (data.hasOwnProperty('used_quota'))
        obj.usedQuota = ApiClient.convertToType(data['used_quota'], 'Number');
      if (data.hasOwnProperty('created_date'))
        obj.createdDate = ApiClient.convertToType(data['created_date'], 'String');
      if (data.hasOwnProperty('modified_date'))
        obj.modifiedDate = ApiClient.convertToType(data['modified_date'], 'String');
      if (data.hasOwnProperty('used_quota_private'))
        obj.usedQuotaPrivate = ApiClient.convertToType(data['used_quota_private'], 'Number');
      if (data.hasOwnProperty('used_quota_public'))
        obj.usedQuotaPublic = ApiClient.convertToType(data['used_quota_public'], 'Number');
      if (data.hasOwnProperty('group_id'))
        obj.groupId = ApiClient.convertToType(data['group_id'], 'Number');
      if (data.hasOwnProperty('account_id'))
        obj.accountId = ApiClient.convertToType(data['account_id'], 'Number');
      if (data.hasOwnProperty('custom_fields'))
        obj.customFields = ApiClient.convertToType(data['custom_fields'], [CustomArticleField]);
    }
    return obj;
  }

  exports.prototype = Object.create(ProjectPrivate.prototype);
  exports.prototype.constructor = exports;
  /**
   * Project funding
   * @member {String} funding
   */
  exports.prototype.funding = undefined;

  /**
   * Full Project funding information
   * @member {Array.<module:model/FundingInformation>} fundingList
   */
  exports.prototype.fundingList = undefined;

  /**
   * Project description
   * @member {String} description
   */
  exports.prototype.description = undefined;

  /**
   * List of project collaborators
   * @member {Array.<module:model/Collaborator>} collaborators
   */
  exports.prototype.collaborators = undefined;

  /**
   * Project quota
   * @member {Number} quota
   */
  exports.prototype.quota = undefined;

  /**
   * Project used quota
   * @member {Number} usedQuota
   */
  exports.prototype.usedQuota = undefined;

  /**
   * Date when project was created
   * @member {String} createdDate
   */
  exports.prototype.createdDate = undefined;

  /**
   * Date when project was last modified
   * @member {String} modifiedDate
   */
  exports.prototype.modifiedDate = undefined;

  /**
   * Project private quota used
   * @member {Number} usedQuotaPrivate
   */
  exports.prototype.usedQuotaPrivate = undefined;

  /**
   * Project public quota used
   * @member {Number} usedQuotaPublic
   */
  exports.prototype.usedQuotaPublic = undefined;

  /**
   * Group of project if any
   * @member {Number} groupId
   */
  exports.prototype.groupId = undefined;

  /**
   * ID of the account owning the project
   * @member {Number} accountId
   */
  exports.prototype.accountId = undefined;

  /**
   * Collection custom fields
   * @member {Array.<module:model/CustomArticleField>} customFields
   */
  exports.prototype.customFields = undefined;


  // Implement ProjectPrivate interface:
  /**
   * Api endpoint
   * @member {String} url
   */
  exports.prototype.url = undefined;

  /**
   * Project id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Project title
   * @member {String} title
   */
  exports.prototype.title = undefined;

  return exports;

}));
