/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CustomArticleFieldAdd', 'model/FundingCreate'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CustomArticleFieldAdd'), require('./FundingCreate'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ProjectCreate = factory(root.FigshareApi.ApiClient, root.FigshareApi.CustomArticleFieldAdd, root.FigshareApi.FundingCreate);
  }
}(this, function(ApiClient, CustomArticleFieldAdd, FundingCreate) {
  'use strict';

  /**
   * The ProjectCreate model module.
   * @module model/ProjectCreate
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ProjectCreate</code>.
   * @alias module:model/ProjectCreate
   * @class
   * @param title {String} The title for this project - mandatory. 3 - 1000 characters.
   */
  var exports = function(title) {
    this.title = title;
  };

  /**
   * Constructs a <code>ProjectCreate</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectCreate} obj Optional instance to populate.
   * @return {module:model/ProjectCreate} The populated <code>ProjectCreate</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('title'))
        obj.title = ApiClient.convertToType(data['title'], 'String');
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('funding'))
        obj.funding = ApiClient.convertToType(data['funding'], 'String');
      if (data.hasOwnProperty('funding_list'))
        obj.fundingList = ApiClient.convertToType(data['funding_list'], [FundingCreate]);
      if (data.hasOwnProperty('group_id'))
        obj.groupId = ApiClient.convertToType(data['group_id'], 'Number');
      if (data.hasOwnProperty('custom_fields'))
        obj.customFields = ApiClient.convertToType(data['custom_fields'], Object);
      if (data.hasOwnProperty('custom_fields_list'))
        obj.customFieldsList = ApiClient.convertToType(data['custom_fields_list'], [CustomArticleFieldAdd]);
    }
    return obj;
  }

  /**
   * The title for this project - mandatory. 3 - 1000 characters.
   * @member {String} title
   */
  exports.prototype.title = undefined;

  /**
   * Project description
   * @member {String} description
   */
  exports.prototype.description = undefined;

  /**
   * Grant number or organization(s) that funded this project. Up to 2000 characters permitted.
   * @member {String} funding
   */
  exports.prototype.funding = undefined;

  /**
   * Funding creation / update items
   * @member {Array.<module:model/FundingCreate>} fundingList
   */
  exports.prototype.fundingList = undefined;

  /**
   * Only if project type is group.
   * @member {Number} groupId
   */
  exports.prototype.groupId = undefined;

  /**
   * List of key, values pairs to be associated with the project
   * @member {Object} customFields
   */
  exports.prototype.customFields = undefined;

  /**
   * List of custom fields values, supersedes custom_fields parameter
   * @member {Array.<module:model/CustomArticleFieldAdd>} customFieldsList
   */
  exports.prototype.customFieldsList = undefined;


  return exports;

}));
