/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ProjectNote = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The ProjectNote model module.
   * @module model/ProjectNote
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ProjectNote</code>.
   * @alias module:model/ProjectNote
   * @class
   * @param id {Number} Project note id
   * @param userId {Number} User who wrote the note
   * @param _abstract {String} Note Abstract - short/truncated content
   * @param userName {String} Username of the one who wrote the note
   * @param createdDate {String} Date when note was created
   * @param modifiedDate {String} Date when note was last modified
   */
  var exports = function(id, userId, _abstract, userName, createdDate, modifiedDate) {
    this.id = id;
    this.userId = userId;
    this._abstract = _abstract;
    this.userName = userName;
    this.createdDate = createdDate;
    this.modifiedDate = modifiedDate;
  };

  /**
   * Constructs a <code>ProjectNote</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectNote} obj Optional instance to populate.
   * @return {module:model/ProjectNote} The populated <code>ProjectNote</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('user_id'))
        obj.userId = ApiClient.convertToType(data['user_id'], 'Number');
      if (data.hasOwnProperty('abstract'))
        obj._abstract = ApiClient.convertToType(data['abstract'], 'String');
      if (data.hasOwnProperty('user_name'))
        obj.userName = ApiClient.convertToType(data['user_name'], 'String');
      if (data.hasOwnProperty('created_date'))
        obj.createdDate = ApiClient.convertToType(data['created_date'], 'String');
      if (data.hasOwnProperty('modified_date'))
        obj.modifiedDate = ApiClient.convertToType(data['modified_date'], 'String');
    }
    return obj;
  }

  /**
   * Project note id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * User who wrote the note
   * @member {Number} userId
   */
  exports.prototype.userId = undefined;

  /**
   * Note Abstract - short/truncated content
   * @member {String} _abstract
   */
  exports.prototype._abstract = undefined;

  /**
   * Username of the one who wrote the note
   * @member {String} userName
   */
  exports.prototype.userName = undefined;

  /**
   * Date when note was created
   * @member {String} createdDate
   */
  exports.prototype.createdDate = undefined;

  /**
   * Date when note was last modified
   * @member {String} modifiedDate
   */
  exports.prototype.modifiedDate = undefined;


  return exports;

}));
