/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Project'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Project'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ProjectPrivate = factory(root.FigshareApi.ApiClient, root.FigshareApi.Project);
  }
}(this, function(ApiClient, Project) {
  'use strict';

  /**
   * The ProjectPrivate model module.
   * @module model/ProjectPrivate
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ProjectPrivate</code>.
   * @alias module:model/ProjectPrivate
   * @class
   * @extends module:model/Project
   * @implements module:model/Project
   * @param url {String} Api endpoint
   * @param id {Number} Project id
   * @param title {String} Project title
   */
  var exports = function(url, id, title) {
    Project.call(this, url, id, title);
    Project.call(this, url, id, title);
    this.role = role;
    this.storage = storage;
  };

  /**
   * Constructs a <code>ProjectPrivate</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProjectPrivate} obj Optional instance to populate.
   * @return {module:model/ProjectPrivate} The populated <code>ProjectPrivate</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      Project.constructFromObject(data, obj);
      Project.constructFromObject(data, obj);
      if (data.hasOwnProperty('role'))
        obj.role = ApiClient.convertToType(data['role'], 'String');
      if (data.hasOwnProperty('storage'))
        obj.storage = ApiClient.convertToType(data['storage'], 'String');
    }
    return obj;
  }

  exports.prototype = Object.create(Project.prototype);
  exports.prototype.constructor = exports;
  /**
   * Role inside this project
   * @member {module:model/ProjectPrivate.RoleEnum} role
   */
  exports.prototype.role = undefined;

  /**
   * Project storage type
   * @member {module:model/ProjectPrivate.StorageEnum} storage
   */
  exports.prototype.storage = undefined;


  // Implement Project interface:
  /**
   * Api endpoint
   * @member {String} url
   */
  exports.prototype.url = undefined;

  /**
   * Project id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Project title
   * @member {String} title
   */
  exports.prototype.title = undefined;


  /**
   * Allowed values for the <code>role</code> property.
   * @enum {String}
   * @readonly
   */
  exports.RoleEnum = {
    /**
     * value: "Owner"
     * @const
     */
    owner: "Owner",

    /**
     * value: "Collaborator"
     * @const
     */
    collaborator: "Collaborator",

    /**
     * value: "Viewer"
     * @const
     */
    viewer: "Viewer"
  };


  /**
   * Allowed values for the <code>storage</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StorageEnum = {
    /**
     * value: "individual"
     * @const
     */
    individual: "individual",

    /**
     * value: "group"
     * @const
     */
    group: "group"
  };

  return exports;

}));
