/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.RelatedMaterial = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The RelatedMaterial model module.
   * @module model/RelatedMaterial
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>RelatedMaterial</code>.
   * @alias module:model/RelatedMaterial
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>RelatedMaterial</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RelatedMaterial} obj Optional instance to populate.
   * @return {module:model/RelatedMaterial} The populated <code>RelatedMaterial</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('identifier'))
        obj.identifier = ApiClient.convertToType(data['identifier'], 'String');
      if (data.hasOwnProperty('title'))
        obj.title = ApiClient.convertToType(data['title'], 'String');
      if (data.hasOwnProperty('relation'))
        obj.relation = ApiClient.convertToType(data['relation'], 'String');
      if (data.hasOwnProperty('identifier_type'))
        obj.identifierType = ApiClient.convertToType(data['identifier_type'], 'String');
      if (data.hasOwnProperty('is_linkout'))
        obj.isLinkout = ApiClient.convertToType(data['is_linkout'], 'Boolean');
      if (data.hasOwnProperty('link'))
        obj.link = ApiClient.convertToType(data['link'], 'String');
    }
    return obj;
  }

  /**
   * The ID of the related material; can be used to add existing materials of the same account to items.
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The related material identifier (e.g., DOI, Handle, ISBN). Mandatory if creating a new material.
   * @member {String} identifier
   */
  exports.prototype.identifier = undefined;

  /**
   * The related material title
   * @member {String} title
   */
  exports.prototype.title = undefined;

  /**
   * The relation between the item and the related material; defaults to 'References'. Mandatory if creating a new material.
   * @member {module:model/RelatedMaterial.RelationEnum} relation
   * @default 'References'
   */
  exports.prototype.relation = 'References';

  /**
   * The type of the identifier of the related material; defaults to 'URL'. Mandatory if creating a new material.
   * @member {module:model/RelatedMaterial.IdentifierTypeEnum} identifierType
   * @default 'URL'
   */
  exports.prototype.identifierType = 'URL';

  /**
   * Flag for highlighting this related material in the call-out box
   * @member {Boolean} isLinkout
   */
  exports.prototype.isLinkout = undefined;

  /**
   * The full hyperlink for the identifier. Automatically generated by Figshare.
   * @member {String} link
   */
  exports.prototype.link = undefined;



  /**
   * Allowed values for the <code>relation</code> property.
   * @enum {String}
   * @readonly
   */
  exports.RelationEnum = {
    /**
     * value: "IsCitedBy"
     * @const
     */
    isCitedBy: "IsCitedBy",

    /**
     * value: "Cites"
     * @const
     */
    cites: "Cites",

    /**
     * value: "IsSupplementTo"
     * @const
     */
    isSupplementTo: "IsSupplementTo",

    /**
     * value: "IsSupplementedBy"
     * @const
     */
    isSupplementedBy: "IsSupplementedBy",

    /**
     * value: "IsContinuedBy"
     * @const
     */
    isContinuedBy: "IsContinuedBy",

    /**
     * value: "Continues"
     * @const
     */
    continues: "Continues",

    /**
     * value: "Describes"
     * @const
     */
    describes: "Describes",

    /**
     * value: "IsDescribedBy"
     * @const
     */
    isDescribedBy: "IsDescribedBy",

    /**
     * value: "HasMetadata"
     * @const
     */
    hasMetadata: "HasMetadata",

    /**
     * value: "IsMetadataFor"
     * @const
     */
    isMetadataFor: "IsMetadataFor",

    /**
     * value: "HasVersion"
     * @const
     */
    hasVersion: "HasVersion",

    /**
     * value: "IsVersionOf"
     * @const
     */
    isVersionOf: "IsVersionOf",

    /**
     * value: "IsNewVersionOf"
     * @const
     */
    isNewVersionOf: "IsNewVersionOf",

    /**
     * value: "IsPreviousVersionOf"
     * @const
     */
    isPreviousVersionOf: "IsPreviousVersionOf",

    /**
     * value: "IsPartOf"
     * @const
     */
    isPartOf: "IsPartOf",

    /**
     * value: "HasPart"
     * @const
     */
    hasPart: "HasPart",

    /**
     * value: "IsPublishedIn"
     * @const
     */
    isPublishedIn: "IsPublishedIn",

    /**
     * value: "IsReferencedBy"
     * @const
     */
    isReferencedBy: "IsReferencedBy",

    /**
     * value: "References"
     * @const
     */
    references: "References",

    /**
     * value: "IsDocumentedBy"
     * @const
     */
    isDocumentedBy: "IsDocumentedBy",

    /**
     * value: "Documents"
     * @const
     */
    documents: "Documents",

    /**
     * value: "IsCompiledBy"
     * @const
     */
    isCompiledBy: "IsCompiledBy",

    /**
     * value: "Compiles"
     * @const
     */
    compiles: "Compiles",

    /**
     * value: "IsVariantFormOf"
     * @const
     */
    isVariantFormOf: "IsVariantFormOf",

    /**
     * value: "IsOriginalFormOf"
     * @const
     */
    isOriginalFormOf: "IsOriginalFormOf",

    /**
     * value: "IsIdenticalTo"
     * @const
     */
    isIdenticalTo: "IsIdenticalTo",

    /**
     * value: "IsReviewedBy"
     * @const
     */
    isReviewedBy: "IsReviewedBy",

    /**
     * value: "Reviews"
     * @const
     */
    reviews: "Reviews",

    /**
     * value: "IsDerivedFrom"
     * @const
     */
    isDerivedFrom: "IsDerivedFrom",

    /**
     * value: "IsSourceOf"
     * @const
     */
    isSourceOf: "IsSourceOf",

    /**
     * value: "IsRequiredBy"
     * @const
     */
    isRequiredBy: "IsRequiredBy",

    /**
     * value: "Requires"
     * @const
     */
    requires: "Requires",

    /**
     * value: "IsObsoletedBy"
     * @const
     */
    isObsoletedBy: "IsObsoletedBy",

    /**
     * value: "Obsoletes"
     * @const
     */
    obsoletes: "Obsoletes"
  };


  /**
   * Allowed values for the <code>identifierType</code> property.
   * @enum {String}
   * @readonly
   */
  exports.IdentifierTypeEnum = {
    /**
     * value: "ARK"
     * @const
     */
    ARK: "ARK",

    /**
     * value: "arXiv"
     * @const
     */
    arXiv: "arXiv",

    /**
     * value: "bibcode"
     * @const
     */
    bibcode: "bibcode",

    /**
     * value: "DOI"
     * @const
     */
    DOI: "DOI",

    /**
     * value: "EAN13"
     * @const
     */
    eAN13: "EAN13",

    /**
     * value: "EISSN"
     * @const
     */
    EISSN: "EISSN",

    /**
     * value: "Handle"
     * @const
     */
    handle: "Handle",

    /**
     * value: "IGSN"
     * @const
     */
    IGSN: "IGSN",

    /**
     * value: "ISBN"
     * @const
     */
    ISBN: "ISBN",

    /**
     * value: "ISSN"
     * @const
     */
    ISSN: "ISSN",

    /**
     * value: "ISTC"
     * @const
     */
    ISTC: "ISTC",

    /**
     * value: "LISSN"
     * @const
     */
    LISSN: "LISSN",

    /**
     * value: "LSID"
     * @const
     */
    LSID: "LSID",

    /**
     * value: "PMID"
     * @const
     */
    PMID: "PMID",

    /**
     * value: "PURL"
     * @const
     */
    PURL: "PURL",

    /**
     * value: "UPC"
     * @const
     */
    UPC: "UPC",

    /**
     * value: "URL"
     * @const
     */
    URL: "URL",

    /**
     * value: "URN"
     * @const
     */
    URN: "URN",

    /**
     * value: "w3id"
     * @const
     */
    w3id: "w3id"
  };

  return exports;

}));
