/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ShortAccount = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The ShortAccount model module.
   * @module model/ShortAccount
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ShortAccount</code>.
   * @alias module:model/ShortAccount
   * @class
   * @param id {Number} Account id
   * @param firstName {String} First Name
   * @param lastName {String} Last Name
   * @param institutionId {Number} Account institution
   * @param email {String} User email
   * @param active {Number} Account activity status
   * @param institutionUserId {String} Account institution user id
   * @param quota {Number} Total storage available to account, in bytes
   * @param usedQuota {Number} Storage used by the account, in bytes
   * @param userId {Number} User id associated with account, useful for example for adding the account as an author to an item
   * @param orcidId {String} ORCID iD associated to account
   */
  var exports = function(id, firstName, lastName, institutionId, email, active, institutionUserId, quota, usedQuota, userId, orcidId) {
    this.id = id;
    this.firstName = firstName;
    this.lastName = lastName;
    this.institutionId = institutionId;
    this.email = email;
    this.active = active;
    this.institutionUserId = institutionUserId;
    this.quota = quota;
    this.usedQuota = usedQuota;
    this.userId = userId;
    this.orcidId = orcidId;
  };

  /**
   * Constructs a <code>ShortAccount</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ShortAccount} obj Optional instance to populate.
   * @return {module:model/ShortAccount} The populated <code>ShortAccount</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('first_name'))
        obj.firstName = ApiClient.convertToType(data['first_name'], 'String');
      if (data.hasOwnProperty('last_name'))
        obj.lastName = ApiClient.convertToType(data['last_name'], 'String');
      if (data.hasOwnProperty('institution_id'))
        obj.institutionId = ApiClient.convertToType(data['institution_id'], 'Number');
      if (data.hasOwnProperty('email'))
        obj.email = ApiClient.convertToType(data['email'], 'String');
      if (data.hasOwnProperty('active'))
        obj.active = ApiClient.convertToType(data['active'], 'Number');
      if (data.hasOwnProperty('institution_user_id'))
        obj.institutionUserId = ApiClient.convertToType(data['institution_user_id'], 'String');
      if (data.hasOwnProperty('quota'))
        obj.quota = ApiClient.convertToType(data['quota'], 'Number');
      if (data.hasOwnProperty('used_quota'))
        obj.usedQuota = ApiClient.convertToType(data['used_quota'], 'Number');
      if (data.hasOwnProperty('user_id'))
        obj.userId = ApiClient.convertToType(data['user_id'], 'Number');
      if (data.hasOwnProperty('orcid_id'))
        obj.orcidId = ApiClient.convertToType(data['orcid_id'], 'String');
    }
    return obj;
  }

  /**
   * Account id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * First Name
   * @member {String} firstName
   */
  exports.prototype.firstName = undefined;

  /**
   * Last Name
   * @member {String} lastName
   */
  exports.prototype.lastName = undefined;

  /**
   * Account institution
   * @member {Number} institutionId
   */
  exports.prototype.institutionId = undefined;

  /**
   * User email
   * @member {String} email
   */
  exports.prototype.email = undefined;

  /**
   * Account activity status
   * @member {Number} active
   */
  exports.prototype.active = undefined;

  /**
   * Account institution user id
   * @member {String} institutionUserId
   */
  exports.prototype.institutionUserId = undefined;

  /**
   * Total storage available to account, in bytes
   * @member {Number} quota
   */
  exports.prototype.quota = undefined;

  /**
   * Storage used by the account, in bytes
   * @member {Number} usedQuota
   */
  exports.prototype.usedQuota = undefined;

  /**
   * User id associated with account, useful for example for adding the account as an author to an item
   * @member {Number} userId
   */
  exports.prototype.userId = undefined;

  /**
   * ORCID iD associated to account
   * @member {String} orcidId
   */
  exports.prototype.orcidId = undefined;


  return exports;

}));
