/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.ShortCustomField = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The ShortCustomField model module.
   * @module model/ShortCustomField
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>ShortCustomField</code>.
   * @alias module:model/ShortCustomField
   * @class
   * @param id {Number} Custom field id
   * @param name {String} Custom field name
   * @param fieldType {module:model/ShortCustomField.FieldTypeEnum} Custom field type
   */
  var exports = function(id, name, fieldType) {
    this.id = id;
    this.name = name;
    this.fieldType = fieldType;
  };

  /**
   * Constructs a <code>ShortCustomField</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ShortCustomField} obj Optional instance to populate.
   * @return {module:model/ShortCustomField} The populated <code>ShortCustomField</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('field_type'))
        obj.fieldType = ApiClient.convertToType(data['field_type'], 'String');
    }
    return obj;
  }

  /**
   * Custom field id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * Custom field name
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * Custom field type
   * @member {module:model/ShortCustomField.FieldTypeEnum} fieldType
   */
  exports.prototype.fieldType = undefined;



  /**
   * Allowed values for the <code>fieldType</code> property.
   * @enum {String}
   * @readonly
   */
  exports.FieldTypeEnum = {
    /**
     * value: "text"
     * @const
     */
    text: "text",

    /**
     * value: "textarea"
     * @const
     */
    textarea: "textarea",

    /**
     * value: "dropdown"
     * @const
     */
    dropdown: "dropdown",

    /**
     * value: "url"
     * @const
     */
    url: "url",

    /**
     * value: "email"
     * @const
     */
    email: "email",

    /**
     * value: "date"
     * @const
     */
    _date: "date",

    /**
     * value: "dropdown_large_list"
     * @const
     */
    dropdownLargeList: "dropdown_large_list"
  };

  return exports;

}));
