/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.UploadFilePart = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The UploadFilePart model module.
   * @module model/UploadFilePart
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>UploadFilePart</code>.
   * @alias module:model/UploadFilePart
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>UploadFilePart</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/UploadFilePart} obj Optional instance to populate.
   * @return {module:model/UploadFilePart} The populated <code>UploadFilePart</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('partNo'))
        obj.partNo = ApiClient.convertToType(data['partNo'], 'Number');
      if (data.hasOwnProperty('startOffset'))
        obj.startOffset = ApiClient.convertToType(data['startOffset'], 'Number');
      if (data.hasOwnProperty('endOffset'))
        obj.endOffset = ApiClient.convertToType(data['endOffset'], 'Number');
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('locked'))
        obj.locked = ApiClient.convertToType(data['locked'], 'Boolean');
    }
    return obj;
  }

  /**
   * File part id
   * @member {Number} partNo
   */
  exports.prototype.partNo = undefined;

  /**
   * Indexes on byte range. zero-based and inclusive
   * @member {Number} startOffset
   */
  exports.prototype.startOffset = undefined;

  /**
   * Indexes on byte range. zero-based and inclusive
   * @member {Number} endOffset
   */
  exports.prototype.endOffset = undefined;

  /**
   * part status
   * @member {module:model/UploadFilePart.StatusEnum} status
   */
  exports.prototype.status = undefined;

  /**
   * When a part is being uploaded it is being locked, by setting the locked flag to true. No changes/uploads can happen on this part from other requests.
   * @member {Boolean} locked
   */
  exports.prototype.locked = undefined;



  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "PENDING"
     * @const
     */
    PENDING: "PENDING",

    /**
     * value: "COMPLETE"
     * @const
     */
    COMPLETE: "COMPLETE"
  };

  return exports;

}));
