/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/UploadFilePart'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./UploadFilePart'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.UploadInfo = factory(root.FigshareApi.ApiClient, root.FigshareApi.UploadFilePart);
  }
}(this, function(ApiClient, UploadFilePart) {
  'use strict';

  /**
   * The UploadInfo model module.
   * @module model/UploadInfo
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>UploadInfo</code>.
   * @alias module:model/UploadInfo
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>UploadInfo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/UploadInfo} obj Optional instance to populate.
   * @return {module:model/UploadInfo} The populated <code>UploadInfo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('token'))
        obj.token = ApiClient.convertToType(data['token'], 'String');
      if (data.hasOwnProperty('md5'))
        obj.md5 = ApiClient.convertToType(data['md5'], 'String');
      if (data.hasOwnProperty('size'))
        obj.size = ApiClient.convertToType(data['size'], 'Number');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('parts'))
        obj.parts = ApiClient.convertToType(data['parts'], [UploadFilePart]);
    }
    return obj;
  }

  /**
   * token received after initializing a file upload
   * @member {String} token
   */
  exports.prototype.token = undefined;

  /**
   * md5 provided on upload initialization
   * @member {String} md5
   */
  exports.prototype.md5 = undefined;

  /**
   * size of file in bytes
   * @member {Number} size
   */
  exports.prototype.size = undefined;

  /**
   * name of file on upload server
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * Upload status
   * @member {module:model/UploadInfo.StatusEnum} status
   */
  exports.prototype.status = undefined;

  /**
   * Uploads parts
   * @member {Array.<module:model/UploadFilePart>} parts
   */
  exports.prototype.parts = undefined;



  /**
   * Allowed values for the <code>status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "PENDING"
     * @const
     */
    PENDING: "PENDING",

    /**
     * value: "COMPLETED"
     * @const
     */
    COMPLETED: "COMPLETED",

    /**
     * value: "ABORTED"
     * @const
     */
    ABORTED: "ABORTED"
  };

  return exports;

}));
