/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.32
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FigshareApi) {
      root.FigshareApi = {};
    }
    root.FigshareApi.User = factory(root.FigshareApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The User model module.
   * @module model/User
   * @version 2.0.0
   */

  /**
   * Constructs a new <code>User</code>.
   * @alias module:model/User
   * @class
   * @param id {Number} User id
   * @param firstName {String} First Name
   * @param lastName {String} Last Name
   * @param name {String} Full Name
   * @param isActive {Boolean} Account activity status
   * @param urlName {String} Name that appears in website url
   * @param isPublic {Boolean} Account public status
   * @param jobTitle {String} User Job title
   * @param orcidId {String} Orcid associated to this User
   */
  var exports = function(id, firstName, lastName, name, isActive, urlName, isPublic, jobTitle, orcidId) {
    this.id = id;
    this.firstName = firstName;
    this.lastName = lastName;
    this.name = name;
    this.isActive = isActive;
    this.urlName = urlName;
    this.isPublic = isPublic;
    this.jobTitle = jobTitle;
    this.orcidId = orcidId;
  };

  /**
   * Constructs a <code>User</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/User} obj Optional instance to populate.
   * @return {module:model/User} The populated <code>User</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('first_name'))
        obj.firstName = ApiClient.convertToType(data['first_name'], 'String');
      if (data.hasOwnProperty('last_name'))
        obj.lastName = ApiClient.convertToType(data['last_name'], 'String');
      if (data.hasOwnProperty('name'))
        obj.name = ApiClient.convertToType(data['name'], 'String');
      if (data.hasOwnProperty('is_active'))
        obj.isActive = ApiClient.convertToType(data['is_active'], 'Boolean');
      if (data.hasOwnProperty('url_name'))
        obj.urlName = ApiClient.convertToType(data['url_name'], 'String');
      if (data.hasOwnProperty('is_public'))
        obj.isPublic = ApiClient.convertToType(data['is_public'], 'Boolean');
      if (data.hasOwnProperty('job_title'))
        obj.jobTitle = ApiClient.convertToType(data['job_title'], 'String');
      if (data.hasOwnProperty('orcid_id'))
        obj.orcidId = ApiClient.convertToType(data['orcid_id'], 'String');
    }
    return obj;
  }

  /**
   * User id
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * First Name
   * @member {String} firstName
   */
  exports.prototype.firstName = undefined;

  /**
   * Last Name
   * @member {String} lastName
   */
  exports.prototype.lastName = undefined;

  /**
   * Full Name
   * @member {String} name
   */
  exports.prototype.name = undefined;

  /**
   * Account activity status
   * @member {Boolean} isActive
   */
  exports.prototype.isActive = undefined;

  /**
   * Name that appears in website url
   * @member {String} urlName
   */
  exports.prototype.urlName = undefined;

  /**
   * Account public status
   * @member {Boolean} isPublic
   */
  exports.prototype.isPublic = undefined;

  /**
   * User Job title
   * @member {String} jobTitle
   */
  exports.prototype.jobTitle = undefined;

  /**
   * Orcid associated to this User
   * @member {String} orcidId
   */
  exports.prototype.orcidId = undefined;


  return exports;

}));
